﻿#SingleInstance Force
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 작성자 : DDART
;; 배포장소 : DDART AUTOMATION
;; https://auto.ddart.net
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
global _app := new CAutosenderApplication("sktdata_autosender", "1.09", "SKT 데이터선물 자동발송기 v1.09 (2020.12.01)")
return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main program
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutosenderApplication extends CApplication
{
	InitApplication()
	{
		this.bRunnable := true
		this.lvReceiver := new CListView("수신정보")
		this.lvReceiver.Show()
		this.LoadReceiver()
	}
	AddHotKey()
	{
		this.hotkeys["F1"] := this.ID_HELP_HELP
		this.hotkeys["F2"] := this.ID_FILE_MAKEEXE
		this.hotkeys["F5"] := this.ID_OPTION_SETTING
		this.hotkeys["F7"] := this.ID_TOOL_EXECUTE
		this.hotkeys["F8"] := this.ID_TOOL_STOP
		this.hotkeys["^a"] := this.ID_EDIT_ADD
		this.hotkeys["^m"] := this.ID_EDIT_MODIFY
		this.hotkeys["F5"] := this.ID_EDIT_INIT
		this.hotkeys["Delete"] := this.ID_EDIT_DELETE
		fn := this.OnHotKey.Bind(this)
		for key, val in % this.hotkeys
		{
			HotKey, %key%, %fn%
		}
	}
	AddMenu()
	{
		this.menu.file := new CMenu("File")
		this.ID_FILE_MAKEEXE := this.menu.file.Add("실행파일 만들기(&M)`tF2")
		this.ID_FILE_EXIT := this.menu.file.Add("종료(&X)")
		
		this.menu.option := new CMenu("Option")
		this.ID_OPTION_SETTING := this.menu.option.Add("설정(&S)`tF5")
		this.menu.edit := new CMenu("Edit")
		this.ID_EDIT_ADD := this.menu.edit.Add("추가(&A)`tCtrl+A")
		this.ID_EDIT_MODIFY := this.menu.edit.Add("수정(&M)`tCtrl+M")
		this.ID_EDIT_DELETE := this.menu.edit.Add("삭제(&D)`tDel")
		this.ID_EDIT_INIT := this.menu.edit.Add("초기화(&I)`tF5")
		this.menu.tool := new CMenu("Tool")
		this.ID_TOOL_EXECUTE := this.menu.tool.Add("실행(&R)`tF7") 
		this.ID_TOOL_STOP := this.menu.tool.Add("중지(&S)`tF8") 
		this.ID_TOOL_CHROMELAUNCH := this.menu.tool.Add("개발자 모드 크롬(&C)")
		
		this.menu.help := new CMenu("Help")
		this.ID_HELP_HELP := this.menu.help.Add("도움말(&H)`tF1")
		this.ID_HELP_UPDATE := this.menu.help.Add("업데이트 확인(&U)")
		this.menu.bar := new CMenu("MenuBar")
		this.menu.bar.Add("파일(&F)", this.menu.file)
		this.menu.bar.Add("편집(&E)", this.menu.edit)
		this.menu.bar.Add("도구(&T)", this.menu.tool)
		this.menu.bar.Add("옵션(&O)", this.menu.option)
		this.menu.bar.Add("도움말(&H)", this.menu.help)
		Gui, Menu, % this.menu.bar.name
	}
	AddToolbar()
	{
		buttons := Array()
		icons := Array()
		if (A_OSVersion = "WIN_7")
		{
			icons := [152, 151, 140, 16, 25, 156, 107]
		}
		else if (InStr(A_OSVersion, "WIN_8"))
		{
			icons := [123, 138, 127, 12, 18, 143, 94]
		}
		else if (this.GetWin10Version() >= 1803)
		{
			icons := [133, 36, 125, 12, 18, 136, 92]
		}
		else
		{
			icons := [119, 134, 123, 12, 18, 139, 90]
		}
		buttons.Push(new CToolbarButton(this.ID_EDIT_INIT, "초기화", icons[1]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_DELETE, "삭 제", icons[2]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_MODIFY, "수 정", icons[3]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_ADD, "추 가", icons[4]))
		buttons.Push(new CToolbarButton(this.ID_OPTION_SETTING, "설 정", icons[5]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_STOP, "중 지", icons[6]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_EXECUTE, "실 행", icons[7]))
		il := IL_Create(buttons.MaxIndex(), 2, true)
		Loop, % buttons.MaxIndex()
		{
			IL_Add(il, buttons[A_Index].icofile, buttons[A_Index].icono)
		}
		this.toolbar.SetImageList(il)
		this.toolbar.SetButtonWidth(80 * this.m, 100 * this.m) 
		Loop, % buttons.MaxIndex()
		{
			this.toolbar.AddButton(A_Index -1, buttons[A_Index].id, buttons[A_Index].text)
		}
		this.toolbar.AutoSize()
		this.toolbar.SetMaxTextRows(1)
	}
	AppendLogBar(title)
	{
		this.AppendLog("_______________________________________________________________<" title ">______")
	}
	LoadSetting()
	{
		this.setting := new CAutosenderSetting()
		base.LoadSetting()
	}
	LoadReceiver()
	{
		col := 1
		this.lvReceiver.InsertCol(col++, "100 sort ", "이름")
		this.lvReceiver.InsertCol(col++, "200 sort center", "수신번호")
		this.lvReceiver.InsertCol(col++, "100 sort float right", "선물 용량(GB)")
		this.lvReceiver.InsertCol(col++, "100 float right", "보낸 용량(GB)")
		this.lvReceiver.InsertCol(col++, "100 float right", "남은 용량(GB)")
		Loop, % this.setting.receivers.MaxIndex()
		{
			rv := this.setting.receivers[A_Index]
			this.lvReceiver.Add("", rv.name, rv.phone, rv.total, rv.sent, rv.left)
		}
		this.OnContentChanged()
	}
	ResizeOnce()
	{
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		w := this.w 
		h := this.h
		if (!w || !h)
		{
			return
		}
		this.setting.width := w
		this.setting.height := h
		margin := 1
		th := this.toolbar_h
		mh := h - th
		lw := w - margin * 2
		lh := mh / 2 - margin
	
		;아래쪽 컨트롤부터 옮겨야 순간 겹쳐졌던 영역이 페인트 안되는 문제를 방지할수 있다.
		this.lvReceiver.Move(margin, margin + th, lw, lh)
		this.tabLog.Move(margin, margin + th + lh, lw, lh)
		this.toolbar.Move(margin, margin, lw, th)
	}
	Run()
	{
		timer := this.fnRun
		SetTimer, %timer%, Off
		
		if (this.lvReceiver.GetCount())
		{
			this.InitLog()
			this.AppendLogBar("실행 시작")
			datasender := new CSTKDataSenderCR()
			if (datasender.Init(this.setting.fetcher))
			{
				this.AppendLog(datasender.GetBrowserInfo())
				this.AppendLogBar("자동선물 시작")
				if (datasender.AutoSend(this.lvReceiver))
				{
					this.AppendLogBar("자동선물 완료")
				}
				else
				{
					this.AppendLogBar("자동선물 중단")
					this.AppendLog(datasender.GetError())
				}
			}
			else
			{
				this.AppendLog(datasender.GetError())
			}		
			this.AppendLogBar("실행 종료")
		}
		else
		{
			this.AppendLog("수신자를 추가해주세요")
		}
		this.ResetRunState()
	}
	SaveReceiver()
	{
		this.setting.receivers := []
		Loop, % this.lvReceiver.GetCount()
		{
			row := A_Index
			receiver := {}
			col := 1
			receiver.name := this.lvReceiver.GetText(row, col++)
			receiver.phone := this.lvReceiver.GetText(row, col++)
			receiver.total := this.lvReceiver.GetText(row, col++)
			receiver.sent := this.lvReceiver.GetText(row, col++)
			receiver.left := this.lvReceiver.GetText(row, col++)
			this.setting.receivers.Push(receiver)
		}
	}
	SaveSetting()
	{
		this.SaveReceiver()
		base.SaveSetting()
	}
	UpdateButtons()
	{
		if (this.lvReceiver.GetCount() = 0)
		{
			this.bRunnable := false
		}
		base.UpdateButtons()
		this.EnableButton(this.menu.edit, this.ID_EDIT_INIT, !this.bRunning && this.bRunnable)
		this.EnableButton(this.menu.edit, this.ID_EDIT_DELETE, !this.bRunning && this.bRunnable)
		this.EnableButton(this.menu.edit, this.ID_EDIT_MODIFY, !this.bRunning && this.bRunnable)
	}
	OnAdd()
	{
		this.dlgAx := new CReceiverInfoDialog()
		if (this.dlgAx.DoModal())
		{
			this.lvReceiver.Add("", this.dlgAx.name, this.dlgAx.phone, this.dlgAx.amount, 0.0 , Format("{1:.1f}", this.dlgAx.amount))
		}
		this.dlgAx := ""
		this.OnContentChanged()
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		if (id =  this.ID_EDIT_ADD)
		{
			this.OnAdd()
		}
		else if (id =  this.ID_EDIT_MODIFY)
		{
			this.OnModify()
		}
		else if (id =  this.ID_EDIT_DELETE)
		{
			this.OnDelete()
		}
		else if (id =  this.ID_EDIT_INIT)
		{
			this.OnInit()
		}
		else if (id =  this.ID_OPTION_SETTING)
		{
			this.OnOptionSetting()
		}
		else
		{
			base.OnCommand(wParam, lParam, nMsg, hWnd)
		}
	}
	OnContentChanged()
	{
		if (this.bRunnable && this.lvReceiver.GetCount() = 0)
		{
			this.bRunnable := false
			this.UpdateButtons()
		}
		else if (!this.bRunnable && this.lvReceiver.GetCount() > 0)
		{
			this.bRunnable := true
			this.UpdateButtons()
		}
		else
		{
		}
	}
	OnDelete()
	{
		count := 0
		row := 0
		while(row := this.lvReceiver.GetNext(row))
		{
			this.lvReceiver.Delete(row)
			count++
		}
		if (count > 0)
		{
			this.OnContentChanged()
		}
		else
		{
			this.AppendLog("삭제할 번호를 먼저 선택하세요")
		}
	}
	OnErase()
	{
		this.editLog.Clear()
	}
	OnInit()
	{
		count := this.lvReceiver.GetCount()
		if (count)
		{
			Loop, %count%
			{
				this.lvReceiver.Modify(A_Index, "Col4", 0.0)
				this.lvReceiver.Modify(A_Index, "Col5", Format("{1:.1f}", this.lvReceiver.GetText(A_Index, 3)))
			}
			this.AppendLog("보낸 용량, 남은 용량을 초기화했습니다")
		}
	}
	OnModify()
	{
		row := this.lvReceiver.GetNext(0)
		if (row > 0)
		{
			name := this.lvReceiver.GetText(row, 1)
			phone := this.lvReceiver.GetText(row, 2)
			amount := this.lvReceiver.GetText(row, 3)
			sent := this.lvReceiver.GetText(row, 4)
			this.dlgAx  := new CReceiverInfoDialog(name, phone, amount)
			if (this.dlgAx.DoModal())
			{
				this.lvReceiver.Modify(row, "", this.dlgAx.name, this.dlgAx.phone, this.dlgAx.amount, Format("{1:.1f}", sent), Format("{1:.1f}", this.dlgAx.amount - sent))
			}
			this.dlgAx := ""
		}
		else
		{
			this.AppendLog("수정할 번호를 먼저 선택하세요")
		}
	}
	OnOptionSetting()
	{
		this.dlgAx := new CAutoSenderSettingDialog()
		if (this.dlgAx.DoModal(this.setting))
		{
			this.setting := this.dlgAx.setting
		}
		this.dlgAx := ""
		this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
		this.InitChrome()
		this.InitLog()
		this.UpdateButtons()
	}
}
class CApplication extends CWindow
{
	__New(name, version, titletext)
	{
		SetWorkingDir %A_ScriptDir%
		this.name := name
		this.version := version
		this.titletext := titletext
		; GUI
		Gui, +Resize     +HWNDhWnd
		base.__New(hWnd)
		SetWinDelay, -1
		FileEncoding, UTF-8
		Hotkey, IfWinActive, % this.title
		this.m := A_ScreenDPI / 96
		this.toolbar := new CToolbarCtrl()
		this.tabLog := new CTabCtrl()
		this.editLog := new CEditCtrl("로그창", true)
		this.tabLog.Add(this.editLog)
		this.hotkeys := Object()
		this.menu := Object()
		this.AddMenu()
		this.AddToolbar()
		this.AddHotkey()
		this.toolbar_h := Round(42 * this.m)
		; Init
		this.InitIEEmulation()
		this.dlgAx := ""
		this.bRunnable := false
		this.bRunning := false
		this.bLogInit := false
		this.setting := { width : 800, height : 600}
		; 윈도우메세지핸들러
		OnMessage(0x0005, this.OnSize.Bind(this))
		OnMessage(0x004E, this.OnNotify.Bind(this))
		OnMessage(0x0100, this.OnKeyDown.Bind(this))
		OnMessage(0x0111, this.OnCommand.Bind(this))
		OnMessage(0x0112, this.OnSysCommand.Bind(this))
		OnMessage(0x0201, this.OnLButtonDown.Bind(this))
		this.WM_SETTING_CHANGED := 0x10000 + 1
		this.WM_WEBSOCKET_DISCONNECTED := 0x10000+ 2
		OnMessage(this.WM_SETTING_CHANGED, this.OnSettingChanged.Bind(this))
		OnMessage(this.WM_WEBSOCKET_DISCONNECTED, this.OnWebSocketDisconnected.Bind(this))
		; 타이머
		this.fnRun := this.Run.Bind(this)
		this.fnResizeOnce := this.ResizeOnce.Bind(this)
		timer := this.fnResizeOnce
		SetTimer, % timer, 300
		; 기타
		if A_AhkVersion >= 1.1.29
		{
			OnError(this.OnError.Bind(this))
		}
		else
		{
			this.AppendLog("오토핫키 버전(" A_AhkVersion ")이 너무 낮습니다. 최신버전으로 업데이트하세요")
		}
		this.OnUpdateCheck(false)
		this.LoadIcon()
		this.LoadSetting()
		this.InitApplication()
		; 마지막
		this.Show()
		this.ReleaseNote()
		this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
	}
	AddHotKey()
	{
	}
	AddMenu()
	{
	}
	AddToolbar()
	{
	}
	AppendLog(msg)
	{
		FormatTime, TimeString, , HH:mm:ss
		msg := "[" TimeString "] " msg "`r`n"
		this.editLog.AppendText(msg)
	}
	AppendLogBar(title)
	{
		this.AppendLog("__________________________________________________________________________<" title ">______")
	}
	EnableButton(ByRef menu, id, bEnable := true)
	{
		menu.Enable(id, bEnable)
		this.toolbar.Enable(id, bEnable)
	}
	ExitIfStop()
	{
		if (!this.bRunnable)
		{
			this.AppendLog("사용자에 의해 중단되었습니다")
			this.ResetRunState()
			Exit, 1
		}
	}
	GetWin10Version()
	{
		if (!InStr(A_OSVersion, "10."))
		{
			return 0
		}
		RegRead, DisplayVersion , HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion, DisplayVersion
		return DisplayVersion
	}
	InitLog(iSel := 0)
	{
		if (!this.bLogInit)
		{
			this.bLogInit:= true
			this.ResizeOnce()
			this.tabLog.Show()
		}
		this.tabLog.SetCurSel(iSel)
	}
	InitApplication()
	{
		this.bRunnable := true
		this.InitLog()
	}
	InitChrome()
	{
		if (this.chrome && (this.setting.browser = 0 || this.chrome.id = this.setting.browser))
		{
			return
		}
		if (this.setting.browser = 2)
		{
			this.chrome := new CMicrosoftEdge()
		}
		else if (this.setting.browser = 3)
		{
			this.chrome := new CNaverWhale()
		}
		else
		{
			this.chrome := new CChrome()
		}
		if (this.setting.browser)
		{
			this.AppendLog("현재 선택된 브라우저는 " this.chrome.korname " 입니다")
		}
	}
	InitIEEmulation()
	{
		if (!InStr(A_OSVersion, "WIN_") || SubStr(A_OSVersion, 5, 1) >= 7)
		{
            be := {"Default" : 0, "IE7" : 7000, "IE8" : 8000, "IE8STD" : 8888, "IE9" : 9000, "IE9STD" : 9999, "IE10" :10000, "IE10STD" : 10001, "IE11" : 11000, "IE11Edge" : 11001}
			emulation := be.IE11Edge
			RegRead, emul_current, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe
			if (emul_current != emulation)
			{
				RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe, %emulation%
			}
		}
	}
	LoadIcon()
	{
		ico := this.name ".ico"
		if (InStr(A_ScriptName, ".exe") || !FileExist(ico))
		{
			return
		}
		hIcon := LoadPicture(ico, "Icon1 w32 h32", type)
		Gui +LastFound
		SendMessage 0x80, 0, hIcon
	}
	LoadSetting()
	{
		this.setting_file := this.name ".setting.json"
		if (FileExist(this.setting_file))
		{
			FileRead, str, % this.setting_file
			setting := JSON.Load(str)
			for key, val in % setting
			{
				if (!IsObject(val) && RegExMatch("^\d+$", val))
				{
					val := val + 0
				}
				this.setting[key] := val
			}
			this.setting.width := Max(100, this.setting.width)
			this.setting.height := Max(100, this.setting.height)
		}
	}
	ReleaseNote()
	{
		RegRead, ProductName , HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion, ProductName
		win10ver := this.GetWin10Version()
		if (win10ver > 0)
		{
			os := ProductName " 버전 " win10ver " (" A_OSVersion ")"
		}
		else
		{
			os := ProductName
		}
		this.AppendLog("운영체제 : " os ", 오토핫키 : " A_AhkVersion " " (A_IsUnicode ? "Unicode" : "Ansi") " " (A_PtrSize = 8 ? "64" : "32") "-bit")
		if (A_Args.Length() > 1)
		{
			if (InStr(A_Args[1], "ahk_pid"))
			{
				this.InitLog()
				http := new CHttp()
				response := JSON.Load(http.Get("https://auto.ddart.net/download/" this.name "/note"))
				old := A_Args[4]
				note := response.note
				if (note)
				{
					if (old)
					{
						pos := InStr(note, "v" old)
						if (pos)
						{
							note := SubStr(note, pos)
						}
					}
					this.AppendLog(StrReplace(note, "`n", "`r`n"))
				}
				if (InStr(A_Args[5], ".exe"))
				{
					;; 업데이트 전에 exe 파일로 이용중이었음
					this.OnMakeExe()
				}
			}
		}
	}
	ResetRunState()
	{
		this.bRunning := false
		this.bRunnable := true
		this.UpdateButtons()
	}
	ResizeOnce()
	{
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		w := this.w
		h := this.h
		th := this.toolbar_h
		margin := 0
		margin *= this.m, th *= this.m, w *= this.m, h *= this.m
		this.tabLog.Move(margin, margin + th, w, h - th)
		this.toolbar.Move(margin, margin, w, th)
	}
	Run()
	{
		timer := this.fnRun
		SetTimer, %timer%, Off
		this.ResetRunState()
	}
	SaveSetting()
	{
		if (FileExist(this.setting_file))
		{
			FileDelete, % this.setting_file
		}
		FileAppend, % JSON.Dump(this.setting), % this.setting_file, UTF-8
	}
	Show()
	{
		this.w := this.setting.width
		this.h := this.setting.height
;		size := "w" this.w " h" this.h
		size := "w" Round(this.w / this.m ) " h" Round(this.h / this.m)
		this.ResizeOnce()
		Gui, 1:Show, %size%, % this.titletext
	}
	UpdateApplication()
	{
		this.InitLog()
		backup := "backup_v" this.version
		if (!FileExist(backup))
		{
			FileCreateDir, %backup%
		}
		if (RegExMatch(A_ScriptName, "O)(.+)\.(\w{3})", matches))
		{
			name := this.name
			ahk := A_ScriptDir "\" name ".ahk"
			zip := A_ScriptDir "\" name ".zip"
			dst := A_ScriptDir
			if (matches[1] = name)
			{
				FileMove, %name%.ahk, %backup%, true
				FileMove, %name%.exe, %backup%, true
			}
			try
			{
				UrlDownloadToFile, https://auto.ddart.net/download/%name%/current, %zip%
			}
			catch e
			{
				this.AppendLog(e.Message)
			}
			if (FileExist(zip))
			{
				this.AppendLog(zip)
				MsgBox, 4, 업데이트 확인, 업데이트 완료되었습니다. 업데이트반영을 위해 지금 재실행하시겠습니까? , 10
				IfMsgBox, Yes
				{
					obj := ComObjCreate("Shell.Application")
					obj.Namespace(dst).CopyHere(obj.Namespace(zip).items, 4|16)
					ObjRelease(obj)
					FileDelete, %zip%
					args := "ahk_pid " this.GetPID() " version " this.version " " A_ScriptName
					Run, %ahk% %args%
					this.OnFileExit()
				}			
			}
			else
			{
				this.AppendLog("업데이트 다운로드 실패")
			}
		}
	}
	UpdateButtons()
	{
		this.EnableButton(this.menu.tool, this.ID_TOOL_EXECUTE, !this.bRunning && this.bRunnable)
		this.EnableButton(this.menu.tool, this.ID_TOOL_STOP, this.bRunning && this.bRunnable)
	}
	OnChromeLaunch()
	{
		this.chrome.Launch(this.setting.chrome_debugging_port)
	}
	OnClose()
	{
		this.SaveSetting()
		return 0
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		notification_code := wParam >> 16
		if (id = this.ID_FILE_EXIT)
		{
			this.OnFileExit()
		}
		else if (id = this.ID_TOOL_EXECUTE)
		{
			this.OnExecute()
		}
		else if (id = this.ID_TOOL_STOP)
		{
			this.OnStop()
		}
		else if (id = this.ID_TOOL_CHROMELAUNCH)
		{
			this.OnChromeLaunch()
		}
		else if (id = this.ID_HELP_HELP)
		{
			this.OnHelp()
		}
		else if (id = this.ID_HELP_UPDATE)
		{
			this.OnUpdateCheck()
		}
		else if (id = this.ID_FILE_MAKEEXE)
		{
			this.OnMakeExe()
		}
		else
		{
		}
	}
	OnError(error)
	{
		this.AppendLog("오류발생 : " error.File " " error.Line "번째줄")
		this.AppendLog(error.Extra " : " error.Message)
		this.ResetRunState()
		return true
	}
	OnExecute()
	{
		if (this.bRunnable && !this.bRunning)
		{
			this.bRunning := true
			this.UpdateButtons()
			timer := this.fnRun
			SetTimer %timer%, 10, -10
		}		
	}
	OnFileExit()
	{
		this.PostMessage(0x0112, 0xF060, 0)
	}
	OnHelp()
	{
		Run, https://auto.ddart.net/xe/help
	}
	OnHotKey()
	{
		if (!this.Active())
		{
			return 0
		}
		cmd := this.hotkeys[A_ThisHotkey]
		if (cmd)
		{
			this.PostMessage(0x0111, cmd, 0)
		}
		else
		{
		}
	}
	OnKeyDown(wParam, lParam, nMsg, hWnd)
	{
		if (this.dlgAx && hWnd = this.dlgAx.hWndIE && this.dlgAx.iaxie.pi)
		{
			; AxIE에 일부 키 전달안되는 문제. TAB=9, ENTER=13, DELETE=46
			if (wParam = 9 || wParam = 13 || wParam = 46)
			{
				VarSetCapacity(msg, 7*A_PtrSize)
				for i,val in [hWnd, nMsg, wParam, lParam, A_EventInfo, A_GuiX, A_GuiY]
					NumPut(val, msg, (i-1)*A_PtrSize)
				this.dlgAx.iaxie.TranslateAccelerator(&msg)
				; 메세지 루프탈출
				return 0 
			}
		}
	}
	OnLButtonDown(wParam, lParam, nMsg, hWnd)
	{
	}
	OnMakeExe()
	{
		file := A_ScriptDir "\" this.name ".exe"
		ico := A_ScriptDir "\" this.name ".ico"
		compiler := StrReplace(A_AhkPath, "AutoHotkey.exe") "Compiler\Ahk2Exe.exe"
		this.InitLog()
		if (InStr(A_ScriptName, ".exe"))
		{
			this.AppendLog("이미 실행파일로 실행되었습니다.")
			return
		}
		if (!FileExist(compiler))
		{
			this.AppendLog(compiler "를 찾을수 없습니다")
			return 
		}
		if (FileExist(file))
		{
			FileDelete, %file%
			this.AppendLog("기존 " file " 를 지웁니다")
		}
		if (FileExist(ico))
		{
			icon_option = /icon "%ico%"
		}
		RunWait, "%compiler%" /in "%A_ScriptDir%\%A_ScriptName%" /out  "%file%" %icon_option%
		this.AppendLog(file " 가 생성되었습니다")
	}
	OnNotify(wParam, lParam, nMsg, hWnd)
	{
		id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
		if (id = this.tabLog.id)
		{
			TCN_FIRST := - 550
			TCN_SELCHANGE  := (TCN_FIRST - 1)
			TCN_SELCHANGING := (TCN_FIRST - 2)
			code := NumGet(lParam+0, 2 * A_PtrSize, "Int")
			if (code = TCN_SELCHANGE)
			{
				this.tabLog.ShowChild()
			}
		}
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
	}
	OnSize(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd = this.hwnd)
		{
			w := lParam & 0xFFFF
			h := lParam >> 16
			this.w := w
			this.h := h
			timer := this.fnResizeOnce
			SetTimer, % timer, Off
			SetTimer, % timer, On
		}
	}
	OnStop()
	{
		if (this.bRunning && this.bRunnable)
		{
			this.bRunnable := false
			this.UpdateButtons()
		}
	}	
	OnSysCommand(wParam, lParam, nMsg, hWnd)
	{
		if (wParam = 0xF060)
		{
			if (hWnd = this.hwnd)
			{
				if (this.OnClose())
				{
					return true
				}			
				ExitApp
			}
		}
	}
	OnUpdateCheck(bUser := true)
	{
		timestamp := A_Now
		timestamp -= 19700101000000, seconds
		name := this.name
		if (bUser)
		{
			this.InitLog()
		}
		else
		{
			RegRead, DisableAutoUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate
			if (DisableAutoUpdate)
			{
				return
			}
			RegRead, LastUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate
			if (LastUpdate && timestamp - LastUpdate < 12 * 60 * 60)
			{
				return 
			}
		}
		http := new CHttp()
		response := JSON.Load(http.Get("https://auto.ddart.net/download/" name "/version"))
		version := response.version
		RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate, %timestamp%
		if (this.version = version)
		{
			this.AppendLog("현재 " this.version " 버전은 최신버전입니다")
		}
		else if (this.version < version)
		{
			MsgBox, 4, 업데이트확인, 새로운 버전(%version%) 이 있습니다. 다운받으시겠습니까?, 10
			IfMsgBox, Yes
			{
				RegWrite, REG_DWORD , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate, 0
				this.UpdateApplication()
			}
			else if (!bUser)
			{
				RegWrite, REG_DWORD , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate, 1
			}
		}
		else if (!version)
		{
			this.AppendLog("현재 서버문제로 최신버전 확인을 할수가 없습니다")
		}
		else
		{
			this.AppendLog("개발자?")
		}
	}
	OnWebSocketDisconnected()
	{
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Windows & Controls
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CWindow
{
	__New(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " this.hwnd
	}
	Activate()
	{
		WinActivate, % this.title
	}
	Active()
	{
		return WinActive(this.title)
	}
	Exist()
	{
		return WinExist(this.title)
	}
	Get(subcmd)
	{
		WinGet, var, %subcmd%, % this.title
		return var
	}
	GetClass()
	{
		WinGetClass, var, % this.title
		return var
	}
	GetControlList()
	{
		return this.Get("ControlList")
	}
	GetPID()
	{
		return this.Get("PID")
	}
	GetProcessName()
	{
		return this.Get("ProcessName")
	}
	GetTitle()
	{
		WinGetTitle, var, % this.title
		return var
	}
	Move(x, y, w := "", h := "")
	{
		WinMove, % this.title, , x, y, w, h
	}
	Control(name, subcmd, value :="")
	{
		Control, %subcmd%, %value%, %name%, % this.title
	}
	ControlFocus(name := "")
	{
		ControlFocus, %name%, % this.title
	}
	ControlGet(name, subcmd := "hwnd", value := "")
	{
		ControlGet, outvar, %subcmd%, %value%, %name%, % this.title
		return outvar
	}
	ControlGetText(name = "")
	{
		ControlGetText, text, %name%, % this.title
		return text
	}
	ControlSend(name, keys)
	{
		ControlSend, %name%, %keys%, % this.title
	}
	ControlSetText(name, txt)
	{
		ControlSetText, %name%, %txt%, % this.title
	}
	SendMessage(msg, wParam :=0, lParam := 0, timeout := 5000)
	{
		SendMessage, %msg%, %wParam%, %lParam%, , % this.title, , , , %timeout%
	}
	SetTopPos()
	{
		DllCall("SetWindowPos", "uint", this.hwnd, "uint", 0)
	}
	PostMessage(msg, wParam := 0, lParam :=0)
	{
		PostMessage, %msg%, %wParam%, %lParam%, , % this.title
	}
	GetWindowTextLength()
	{
		WM_GETTEXTLENGTH := 0x0E
		this.SendMessage(WM_GETTEXTLENGTH, 0, 0)
		return ErrorLevel
	}
	MakeLong(lo, hi)
	{
		return (hi << 16) | (lo & 0xffff)
	}
}
class CMenu
{
	__New(name)
	{
		this.name := name
	}
	Add(item, sub := "", bEnable := true)
	{
		if (item)
		{
			handler := sub ? ":" sub.name : CMenu.Handler
			Menu, % this.name, Add, %item%, %handler%
			return this.GetLastId()
		}
		else
		{
			Menu, % this.name, Add
		}
	}
	GetLastId()
	{
		hMenu := MenuGetHandle(this.name)
		count := DllCall("GetMenuItemCount", "ptr", hMenu)		
		return DllCall("GetMenuItemID", "ptr", hMenu, "int", count-1)
	}
	GetState(id, flags := 0)
	{
		hMenu := MenuGetHandle(this.name)
		return DllCall("GetMenuState", "ptr", hMenu, "uint", id, "uint", flags)		
	}
	IsEnabled(id)
	{
		return ! this.IsDisabled(id)
	}
	IsDisabled(id)
	{
		return this.GetState(id)  & 3
	}
	Enable(id, bEnable := true)
	{
		hMenu := MenuGetHandle(this.name)
		uEnable := bEnable ? 0x00 : 0x01
		return DllCall("EnableMenuItem", "ptr", hMenu, "uint", id, "uint", uEnable)
	}
	Rename(item, name)
	{
		Menu, % this.name, Rename, %item%, %name%
	}
	Handler(ItemName, ItemPos, MenuName)
	{
	}
}

class CControl extends CWindow
{
	__New(hwnd)
	{
		static id := 3
		base.__New(hwnd)
		this.id := this.GetCtrlID()
	}
	Show(bShow := true)
	{
		this.Control("", bShow ? "Show" : "Hide")
	}
	GetCtrlID()
	{
		GWL_ID := -12
		if (A_PtrSize = 8)
		{
			return DllCall("GetWindowLongPtr", "ptr", this.hwnd, "int", GWL_ID)
		}
		else
		{
			return DllCall("GetWindowLong", "int", this.hwnd, "int", GWL_ID)
		}
	}
	SetCtrlID(id)
	{
		this.id := id
		GWL_ID := -12
		if (A_PtrSize = 8)
		{
			DllCall("SetWindowLongPtr", "ptr", this.hwnd, "int", GWL_ID, "int", id)
		}
		else
		{
			DllCall("SetWindowLong", "int", this.hwnd, "int", GWL_ID, "int", id)
		}
	}
}
class CEditCtrl extends CControl
{
	__New(name, bReadOnly := false)
	{
		this.name := name
		ES_MULTILINE := 0x0004, ES_AUTOVSCROLL := 0x0040, ES_READONLY := 0x0800
		style := ES_MULTILINE | ES_AUTOVSCROLL
		if (bReadOnly)
		{
			style |= ES_READONLY
		}
		Gui, Add, Edit,   HWNDhWnd %style% hidden
		base.__New(hWnd)
	}
	Clear()
	{
		this.SetSel(0, -1)
		text := ""
		this.ReplaceSel(text)
	}
	SetSel(nStartChar, nEndChar)
	{
		EM_SETSEL := 0xB1
		this.SendMessage(EM_SETSEL, nStartChar, nEndChar)
	}
	ReplaceSel(ByRef text, bCanUndo := false)
	{
		EM_REPLACESEL := 0xC2
		this.SendMessage(EM_REPLACESEL, bCanUndo, &text)
	}
	InsertText(nInsertAfterChar, ByRef text, bCanUndo := false)
	{
		this.SetSel(nInsertAfterChar, nInsertAfterChar)
		this.ReplaceSel(text, bCanUndo)
		return ErrorLevel
	}	
	AppendText(ByRef text, bCanUndo :=false)
	{
		this.InsertText(this.GetWindowTextLength(), text, bCanUndo)
	}
	GetLimitText()
	{
		EM_GETLIMITTEXT := 0x00D5
		this.SendMessage(EM_GETLIMITTEXT, 0, 0)
		return ErrorLevel
	}
	SetLimitText(nMax)
	{
		EM_SETLIMITTEXT := 0x00C5
		this.SendMessage(EM_SETLIMITTEXT, nMax, 0)
	}
	
}
class CToolbarCtrl extends CControl
{
	__New()
	{
		TBSTYLE_WRAPABLE := 0x0200, TBSTYLE_FLAT := 0x0800, TBSTYLE_LIST := 0x1000, TBSTYLE_TRANSPARENT := 0x8000, TBSTYLE_EX_MIXEDBUTTONS := 0x00000008, BTNS_SHOWTEXT :=  0x0040
		style := TBSTYLE_WRAPABLE |  TBSTYLE_FLAT | TBSTYLE_LIST |  TBSTYLE_TRANSPARENT |  TBSTYLE_EX_MIXEDBUTTONS  | BTNS_SHOWTEXT
		Gui, Add, Custom, ClassToolbarWindow32 HWNDhWnd %style%
		base.__new(hWnd)
	}
     SetMaxTextRows(MaxRows := 0)
    {
		WM_USER := 0x0400
		TB_SETMAXTEXTROWS :=  (WM_USER + 60)
        this.SendMessage(this.TB_SETMAXTEXTROWS, MaxRows, 0)
        return (ErrorLevel = "FAIL") ? False : true
    }
	
    SetImageList(IL_Default)
    {
		WM_USER := 0x0400
		TB_SETIMAGELIST :=  (WM_USER + 48)
        this.SendMessage(TB_SETIMAGELIST, 0, IL_Default)
        return (ErrorLevel = "FAIL") ? False : true
    }
	SetButtonSize(width, height)
	{
	}
	SetButtonWidth(min, max)
	{
		WM_USER := 0x0400
		TB_SETBUTTONWIDTH := (WM_USER + 59)
		this.SendMessage(TB_SETBUTTONWIDTH, 0, this.MakeLong(min, max))
	}
	Enable(id, bEnable := true)
	{
		TB_ENABLEBUTTON := 0x0401
		this.SendMessage(TB_ENABLEBUTTON, id, bEnable)
	}
	AddString(str)
	{
		WM_USER := 0x0400
		TB_ADDSTRINGA := (WM_USER + 28)
		TB_ADDSTRINGW := (WM_USER + 77)
		TB_ADDSTRING := A_IsUnicode ? TB_ADDSTRINGW : TB_ADDSTRINGA
		VarSetCapacity(pstr, (StrPut(str) * (A_IsUnicode ? 2 : 1), 0))
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		this.SendMessage(TB_ADDSTRING, 0, &pstr)
		return ErrorLevel		
	}
	AddButton(i, id, str := "", state := 0x04, style := 0)
	{
		TBSTATE_ENABLED := 0x04
		WM_USER := 0x0400
		TB_ADDBUTTONS := (WM_USER + 20)
		istr := str ? this.AddString(str) : -1
		VarSetCapacity(ptbbutton, 8 + (A_PtrSize * 3), 0)
		NumPut(i, ptbbutton, 0, "Int")
		NumPut(id, ptbbutton, 4, "Int")
		NumPut(state, ptbbutton, 8, "Char")
		NumPut(style, ptbbutton, 9, "Char")
		NumPut(istr, ptbbutton, 8 + (A_PtrSize * 2), "Ptr")		
		this.SendMessage(TB_ADDBUTTONS, 1, &ptbbutton)
	}
    AutoSize()
    {
		WM_USER := 0x0400
		TB_AUTOSIZE := (WM_USER + 33)
        this.PostMessage(TB_AUTOSIZE, 0, 0)
        return ErrorLevel ? False : true
    }
}
class CToolbarButton
{
	__New(id, text, icono, icofile := "wmploc.dll")
	{
		this.id := id
		this.text := text
		this.icono := icono
		this.icofile := icofile
	}
}
class CRect
{
	__New(l, t, r, b)
	{
		this.l := l + 0
		this.t := t + 0
		this.r := r + 0
		this.b := b + 0
	}
}
class CTabCtrl extends CControl
{
	__New()
	{
		Gui, Add, Custom, ClassSysTabControl32 HWNDhWnd hidden
		base.__New(hWnd)
		this.children := Array()
	}
	Add(child)
	{
		i := this.children.Length()
		this.InsertItem(i, child.name)
		this.children.Push(child)
	}
	AdjustRect(ByRef rc, bLarger := false)
	{
		TCM_FIRST := 0x1300 
		TCM_ADJUSTRECT := (TCM_FIRST + 40)
		VarSetCapacity(prc, 4 * 4, 0)
		NumPut(rc.l, prc, 0, "Int")
		NumPut(rc.t, prc, 4, "Int")
		NumPut(rc.r, prc, 8, "Int")
		NumPut(rc.b, prc, 12, "Int")
		this.SendMessage(TCM_ADJUSTRECT, bLarger, &prc)
		rc.l := NumGet(&prc, 0, "Int")
		rc.t := NumGet(&prc, 4, "Int")
		rc.r := NumGet(&prc, 8, "Int")
		rc.b := NumGet(&prc, 12, "Int")
	}
	Exist(name)
	{
		Loop, % this.children.Length()
		{
			if (this.children[A_Index].name = name)
			{
				return true
			}
		}
		return false
	}
	GetCurSel()
	{
		TCM_FIRST := 0x1300 
		TCM_GETCURSEL := (TCM_FIRST + 11)
		this.SendMessage(TCM_GETCURSEL, 0, 0)
		return ErrorLevel
	}
	GetCurSelName()
	{
		i := this.GetCurSel() + 1
		return this.children[i].name
	}
	GetCurChild()
	{
		return this.children[this.GetCurSel() + 1]
	}
	GetCurChildId()
	{
		return this.children[this.GetCurSel() + 1].id
	}
	HighlightItem(iItem, fHighlight := 1)
	{
		TCM_FIRST := 0x1300 
		TCM_HIGHLIGHTITEM  := (TCM_FIRST + 51)
		this.SendMessage(TCM_HIGHLIGHTITEM, iItem, fHighlight)
	}
	Move(x, y, w, h)
	{
		base.Move(x, y, w, h)
		rc := new CRect(x, y, x+ w, y +h)
		this.AdjustRect(rc)
		Loop, % this.children.MaxIndex()
		{
			if (this.children[A_Index].hwnd)
			{
				this.children[A_Index].Move(rc.l, rc.t, rc.r - rc.l, rc.b - rc.t)
			}
		}
	}
	InsertItem(iItem, str)
	{
		TCM_FIRST := 0x1300 
		TCM_INSERTITEM := A_IsUnicode ? (TCM_FIRST + 62) : (TCM_FIRST + 7)
		TCIF_TEXT := 0x0001
		VarSetCapacity(pitem, A_PtrSize = 8 ? 40 : 28, 0)
		VarSetCapacity(pstr , StrPut(str)*(A_IsUnicode ? 2:1),0)
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		NumPut(TCIF_TEXT,pitem,0,"UInt")                   
		NumPut(&pstr,  pitem,A_PtrSize=8 ? 16:12,"Ptr") 
		NumPut(StrPut(str), pitem,A_PtrSize=8 ? 24:16,"Int")
		this.SendMessage(TCM_INSERTITEM, iItem, &pitem)
	}
	SetCurFocus(iItem)
	{
		TCM_FIRST := 0x1300 
		TCM_SETCURFOCUS  := (TCM_FIRST + 48)
		this.SendMessage(TCM_SETCURFOCUS, iItem, 0)
	}
	SetCurSel(iItem)
	{
		TCM_FIRST := 0x1300 
		TCM_SETCURSEL :=  (TCM_FIRST + 12)
		this.SendMessage(TCM_SETCURSEL, iItem, 0)		
		this.ShowChild()
	}
	Select(name)
	{
		Loop, % this.children.MaxIndex()
		{
			if (name = this.children[A_Index].name)
			{
				this.SetCurSel(A_Index - 1)
				return this.children[A_Index]
			}
		}
	}
	ShowChild()
	{
		if (!this.ControlGet("", "Visible"))
		{
			return
		}
		iSel := this.GetCurSel()
		Loop, % this.children.MaxIndex()
		{
			if (A_Index != iSel + 1)
			{
				this.children[A_Index].Show(false)
			}
		}
		this.children[iSel + 1].Show(true)
		this.children[iSel + 1].ControlFocus()
	}
}
class CListView extends CControl
{
	__New(name, options := "", row_height := 20)
	{
		this.name := name
		Gui, Add, ListView, HWNDhWnd %options% hidden
		DllCall("UxTheme.dll\SetWindowTheme", "Ptr", hWnd, "WStr", "Explorer", "Ptr", 0)		
		LV_SetImageList(DllCall( "ImageList_Create", Int, 1, Int, row_height , Int, 8, Int, 1, Int, 1), 1)
		base.__New(hWnd)
	}
	Activate()
	{
		Gui, ListView, % this.hWnd
	}
	Add(options, cols*)
	{
		this.Activate()
		return LV_Add(options, cols*)
	}
	DeleteAll()
	{
		this.Activate()
		LV_Delete()
	}
	Delete(row)
	{
		this.Activate()
		LV_Delete(row)
	}
	Insert(row, options, cols*)
	{
		this.Activate()
		LV_Insert(row, options, cols*)
	}
	Modify(row, options, cols*)
	{
		this.Activate()
		LV_Modify(row, options, cols*)
	}
	ModifyCol(col, options, title)
	{
		this.Activate()
		LV_ModifyCol(col, options, title)
	}
	InsertCol(col, options, title)
	{
		this.Activate()
		LV_InsertCol(col, options, title)
	}
	DeleteCol(col)
	{
		this.Activate()
		LV_DeleteCol(col)
	}
	GetCount(mode :="")
	{
		this.Activate()
		return LV_GetCount(mode)
	}
	GetNext(params*)
	{
		this.Activate()
		return LV_GetNext(params*)
	}
	GetText(row, col := 1)
	{
		this.Activate()
		LV_GetText(var, row, col)
		return var
	}
	GetSelectedRowText(col := 1)
	{
		if (this.GetCount("S") = 1)
		{
			return this.GetText(this.GetNext(0), 1)
		}
		return ""
	}
	SetImageList(params*)
	{
		this.Activate()
		return LV_SetImageList(params*)
	}
	EnsureVisible(iItem, fPartialOK := 0)
	{
		LVM_FIRST := 0x1000
		LVM_ENSUREVISIBLE := (LVM_FIRST + 19)
		this.SendMessage(LVM_ENSUREVISIBLE, iItem, fPartialOK)
	}
}
class CExplorerView extends CControl
{
	__New(name)
	{
		static wb
		this.name := name
		Gui, Add, ActiveX, HWNDhWnd vwb, Shell.Explorer
		base.__New(hWnd)
		this.wb := wb
		this.SetTopPos()
	}
	Navigate(url)
	{
		this.wb.Navigate(url)
		return true
		Loop, 100
		{
			if (this.wb.document.readyState = "complete")
			{
				return true
			}
			Sleep, 50
		}
		return false
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ModalDialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAxIEEventHandler 
{
	OnKeyPress(doc) 
	{
		static keys := {1:"selectall", 3:"copy", 22:"paste", 24:"cut"}
		keyCode := doc.parentWindow.event.keyCode
		if keys.HasKey(keyCode)
			Doc.ExecCommand(keys[keyCode])
	}
}
class CModalDialog extends CWindow
{
	__New(html, w, h, title := "")
	{
		Gui, popup:+Owner1 +hWndhWnd -Resize -MaximizeBox -MinimizeBox
		Gui, popup:Add, ActiveX, hWndhWndAX x0 y0 w%w% h%h%, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		base.__New(hWnd)
		Sleep, 100
		wb := WBGet("ahk_id " hWndAX)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()		
		Loop, 10
		{
			if (wb.document.readyState = "complete")
			{
				break
			}
			Sleep, 50
		}
		; ComObjConnect 의 첫번째 파라미터는 static, global 변수만.
		static doc
		ComObjConnect(doc:= wb.document, new CAxIEEventHandler)		
		winAX := new CWindow(hWndAX)
		this.hWndIE := winAX.ControlGet("Internet Explorer_Server1")
		this.iaxie := new CIOleInPlaceActiveObject(wb)
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		this.Init()
		Gui, 1:+Disabled
		Gui, popup:Show, w%w% h%h%, %title%
		this.clicked_button := 0
		this.ID_CANCEL := 0
		this.ID_OK := 1
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	OnClick(e)
	{
		if (e.srcElement.type = "button")
		{
			if (e.srcElement.value = "확 인")
			{
				if (!this.ApplyChange())
				{
					return
				}
				this.clicked_button := this.ID_OK
			}
			else
			{
				this.clicked_button := this.ID_CANCEL
			}
			WM_CLOSE := 0x10
			this.PostMessage(WM_CLOSE, 0, 0)
		}
	}
	ApplyChnage()
	{
		return false
	}
	DoModal()
	{
		WinWaitClose, % this.title
		Gui, 1:Show
		Gui, 1:-Disabled
		Gui, popup:Hide
		Gui, popup:Destroy
		return this.clicked_button
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Setting & Dialogs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutosenderSetting
{
	__New()
	{
		this.width := 640
		this.height := 480
		this.browser := 1
		this.fetcher := 0
		this.chrome_debugging_port := 9222
		this.cert_cooldown := 70
		this.cert_retry := 3
		this.receivers := Array()
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutoSenderSettingDialog extends CModalDialog
{
	__New()
	{
		w := 320
		h := 200
		html =
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
html, body {margin:0;padding:0;overflow: hidden;font-size:12px; background-color:#F0F0F0;width:100`%;height:100`%;}
table{width:100`%;height:100`%; border-spacing:0}
.setting td:nth-child(1) {font-size:12px; width: 120px; text-align: right}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input{ border-radius: 3px; border : 1px solid #ADADAD}
.setting input[type=checkbox] {}
.setting input[type=text] {width:60px; text-align:right;}
.setting input[type=button] {font-size:12px; ; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{align:right; padding:10px;}
.separator > td {border-top: 1px solid #ADADAD;}
</style>
<script>
var setting = null;
var proptype_checkbox = {"browser" : true, "fetcher" : true, "fetcher_check_time" : true, "fetcher_filter" : true, "skip_send_logging" : true, "ex_charging_auto" : true, "ex_charging_target" : true};
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(data)
{
	if (data)
	{
		setting = JSON.parse(data);
	}
	setting.browser = 1;
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				elms[i].checked = (i == setting[prop]);
				elms[i].addEventListener("click", OnClickCheckbox)
			}
		}
		else
		{
			var elm = document.getElementById(prop);
			if (elm)
			{
				elm.value = setting[prop];
			}		
		}	
	}
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
	document.getElementById("chrome_display").style.display = (setting.browser == 0) ? "none" : "";
}
function Submit()
{
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				if  (elms[i].checked)
				{
					setting[prop] = i;
					break;
				}
			}
			
		}
		else
		{
			var elm = document.getElementById(prop)
			if (elm)
			{
				setting[prop] = parseInt(elm.value);
			}
		}
	}
	return JSON.stringify(setting);
}
function OnClickCheckbox(e)
{
	var elms = document.getElementsByClassName(e.srcElement.className);
	for (var i=0; i < elms.length; i++)
	{
		if (elms[i] == e.srcElement)
		{
			if (elms[i].className == "browser")
			{
				document.getElementById("chrome_display").style.display = (i == 0) ? "none" : "";
			}
		}
		else
		{
			elms[i].checked = false;
		}
	}
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td>브라우저</td>
	<td> <input type=checkbox disabled class=browser> 익스플로러 <input type=checkbox class=browser>크롬</td>
  </tr>
  <tr id=chrome_display>
    <td>크롬디버거포트</td>
	<td> <input type=text maxlength=5 id=chrome_debugging_port> (default: 9222)</td>
  </tr>
  <tr class=separator>
    <td>문자수신 어플</td>
	<td>
	   <input type=checkbox class=fetcher> 사용자 휴대폰 도우미 <br>
	   <input type=checkbox class=fetcher> 구글메시지웹<input type=checkbox class=fetcher>Pushbullet웹
	</td>
  </tr>
  <tr class=separator>
    <td>인증요청 대기시간</td>
	<td> <input type=text maxlength=3 id=cert_cooldown> 초 (최소 60)</td>
  </tr>
  <tr>
    <td>수신실패시 재요청</td>
	<td> <input type=text maxlength=1 id=cert_retry> 회</td>
  </tr>
  <tr class=separator>
	<td colspan=2 class=bottom> 
	   <input type=button class=button value="취 소">&nbsp; 
	   <input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, w, h, "설정")
	}
	DoModal(setting)
	{
		this.setting := setting
		this.ie.Init(JSON.Dump(this.setting))
		return base.DoModal()
	}
	ApplyChange()
	{
		data := this.ie.Submit()
		setting := JSON.Load(data)
		err := ""
		if (setting.cert_cooldown < 60)
		{
			err .= "인증요청 대기시간은 SK텔레콤의 제한으로 최소 60초 이상 설정해야합니다"
		}
		else if (setting.chrome_debugging_port < 1024 || setting.chrome_debuggin_port > 65535)
		{
			err .= "디버거포트는 1024 ~ 65535 범위내에서만 설정가능합니다."
		}
		if (err)
		{
			MsgBox, 0x10, 입력오류, %err%
			return false
		}
		this.setting := setting
		return true
	}	
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CReceiverInfoDialog extends CModalDialog
{
	__New(n := "", p := "", a := 0)
	{
		this.name := n
		this.phone := p
		this.amount :=a
		
		html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
body { font-size:12px; margin:0px; overflow:hidden;background-color:#F0F0F0}
table{width:300px;height:200px;}
.setting td:nth-child(1) {font-size:12px; width: 100px; text-align: center}
.setting td:nth-child(2) {font-size:12px; padding-left:20px}
.setting input[type=text] { border : 1px solid black; width:120px;}
.setting input[type=button] {font-size:12px; border : 1px solid #ADADAD; background-color:#E1E1E1;width:80px;height:25px; }
td.bottom{text-align:center;}
td.title{text-align:left; color:red;}
</style>
<script>
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(name, phone, amount)
{
	document.getElementById("name").value = name;
	document.getElementById("phone").value = phone;
	document.getElementById("amount").value = amount;
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
}
function Submit()
{
	return {
	"name" : document.getElementById("name").value, 
	"phone" : document.getElementById("phone").value,
	"amount" : document.getElementById("amount").value,
	};
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td>수신자 실명</td>
	<td><input type=text maxlength=4 id=name></td>
  </tr>
  <tr>
    <td>수신자 번호</td>
	<td> <input type=text maxlength=14 id=phone></td>
  </tr>
  <tr>
    <td>선물 용량</td>
	<td> <input type=text maxlength=4 id=amount> GB</td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   	   <input type=button class=button value="취 소">&nbsp;
			<input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, 300, 200, "수신자 추가")
	}
	__Delete()
	{
	}
	DoModal()
	{
		this.ie.Init(this.name, this.phone, this.amount)
		return base.DoModal()
	}
	ApplyChange()
	{
		ret := this.ie.Submit()
		phone := RegExReplace(ret.phone, "[^\d]")
		if (StrLen(phone) != 11 && StrLen(phone) != 10)
		{
			MsgBox, 0x10, 입력오류, 전화번호 길이가 맞지않습니다.
			return false
		}
		name := RegExReplace(ret.name, "\s")
		if (StrLen(name) >= 5)
		{
			MsgBox, 0x10, 입력오류, 실명은 4자이하로 입력하세요.
			return false
		}
		amount := RegExReplace(ret.amount, "[^\d\.]")
		if (StrLen(amount) >= 5 || RegExMatch(amount, "\.\d{2,}"))
		{
			MsgBox, 0x10, 입력오류, 선물 용량 소수점이하 한자리까지 99기가 이하입니다.
			return false
		}
		this.phone := SubStr(phone, 1, 3) "-" SubStr(phone, 4, 4) "-" SubStr(phone, 8, 4)
		this.name := name
		this.amount := amount
		return true
	}
}	






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COM support & helper classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vt(p,n)
{
	return NumGet(NumGet(p+0,"ptr")+n*A_PtrSize,"ptr")
}
_Error(a,b)
{
	static err:={0x8000FFFF:"Catastrophic failure error.",0x80004001:"Not implemented error.",0x8007000E:"Out of memory error.",0x80070057:"One or more arguments are not valid error.",0x80004002:"Interface not supported error.",0x80004003:"Pointer not valid error.",0x80070006:"Handle not valid error.",0x80004004:"Operation aborted error.",0x80004005:"Unspecified error.",0x80070005:"General access denied error.",0x800401E5:"The object identified by this moniker could not be found."
		,0x80040201:"UIA_E_ELEMENTNOTAVAILABLE",0x80040200:"UIA_E_ELEMENTNOTENABLED",0x80131509:"UIA_E_INVALIDOPERATION",0x80040202:"UIA_E_NOCLICKABLEPOINT",0x80040204:"UIA_E_NOTSUPPORTED",0x80040203:"UIA_E_PROXYASSEMBLYNOTLOADED"} ; //not completed
	if a && (a&=0xFFFFFFFF)
	return a
}
class CCOMInterface
{
	__New(pi)
	{
		this.pi := pi
	}
	__Delete()
	{
		if (this.pi)
		{
			ObjRelease(this.pi)
		}
	}
}
class CIOleInPlaceActiveObject extends CCOMInterface
{
	__New(obj)
	{
		this.iid := "{00000117-0000-0000-C000-000000000046}"
		base.__New(ComObjQuery(obj, this.iid))
	}
	TranslateAccelerator(pMsg)
	{
		_Error(DllCall(vt(this.pi, 5),"ptr",this.pi,"ptr",pMsg), A_ThisFunc)
	}
}
class CCUIAutomation extends CCOMInterface
{
	__New()
	{
		this.clsid := "{ff48dba4-60ef-4201-aa87-54103eef594e}"
		this.iid := "{30cbe57d-d9d0-452a-ab13-7ac5ac4825ee}"
		base.__New(ComObjCreate(this.clsid, this.iid))
	}
	ElementFromHandle(hWnd)
	{
		_Error(DllCall(vt(this.pi, 6),"ptr",this.pi,"ptr",hWnd,"ptr*",element), A_ThisFunc)
		return element
	}
	CreateTrueCondition()
	{
		_Error(DllCall(vt(this.pi, 21),"ptr",this.pi,"ptr*",newCondition), A_ThisFunc)
		return newCondition
	}
}
class CIUIAutomationElement extends CCOMInterface
{
	FindAll(scope, condition)
	{
		_Error(DllCall(vt(this.pi, 6),"ptr",this.pi,"int",scope,"ptr",condition,"ptr*",found), A_ThisFunc)
		return found
	}
	GetControlPattern(patternId)
	{
		_Error(DllCall(vt(this.pi,16),"ptr",this.pi,"int",patternId,"ptr*",patternObject), A_ThisFunc)
		return patternObject
	}
	CurrentControlType()
	{
		_Error(DllCall(vt(this.pi,21),"ptr",this.pi,"uint*", type), A_ThisFunc)
		return type
	}
	CurrentName()
	{
		_Error(DllCall(vt(this.pi, 23),"ptr",this.pi,"ptr*",retVal), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
}
class CIUIAutomationElementArray extends CCOMInterface
{
	GetLength()
	{
		_Error(DllCall(vt(this.pi, 3),"ptr",this.pi,"int*",length), A_ThisFunc)
		return length
	}
	GetElement(index)
	{
		_Error(DllCall(vt(this.pi, 4),"ptr",this.pi,"int",index,"ptr*",element), A_ThisFunc)
		return element
	}
}
class CIUIAutomationScrollPattern extends CCOMInterface
{
	Scroll(horizontalAmount,verticalAmount)
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi,"int",horizontalAmount,"int",verticalAmount), A_ThisFunc)
	}
	SetScrollPercent(horizontalPercent,verticalPercent)
	{
		return _Error(DllCall(vt(this.pi,4),"ptr",this.pi,"double",horizontalPercent,"double",verticalPercent), A_ThisFunc)
	}
	CurrentVerticalViewSize()
	{
		_Error(DllCall(vt(this.pi,8),"ptr",this.pi,"double*",retVal), A_ThisFunc)
		return retVal
	}
}
class CHTTP
{
	__New()
	{
		this.http := ComObjCreate(A_OSVersion = "WIN_7" ? "Msxml2.XMLHTTP" : "WinHttp.WinHttpRequest.5.1")
	}
	__Delete()
	{
		if (this.http)
		{
			ObjRelease(this.http)
		}
	}
	Win7WinHttpTLS12Support()
	{
		; WIN_7 에서 WinHttp.WinHttpRequest.5.1로 httprequest 할 경우 TLS 1.2 보안채널 사용하게 하기위한 코드 백업. 
		; TLS 1.2 미만은 최신 서버, 브라우저들에서 더이상 사용되지 않는데 win 7 winhttp에선 tls 1.2가 default 로 사용되지 않는다.
		; 아래 레지스트리작업을 위해서는 관리자권한을 사용자에게 요구해야하므로 아래 코드를 쓰지않고 Msxml2.XMLHTTP 로 대체해서 해결함. 
		if (A_OSVersion != "WIN_7")
			return
		RegRead, DefaultSecureProtocols, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols
		if !(DefaultSecureProtocols & 0x800)
		{
			if (A_IsAdmin)
			{
				commandLine := DllCall("GetCommandLine", "str")
				isRestarted := !!RegExMatch(commandLine, " /restart(?!\S)")
				if (A_Is64bitOS)
				{
					RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols, 0xA00
				}
				RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols, 0xA00
				if (isRestarted)
				{
					MsgBox, 레지스트리값을 설정완료후 프로그램을 종료합니다. 일반권한으로 자동입력기를 다시 실행해주세요.
					ExitApp
				}
			}
			else 
			{
				MsgBox, 4, 자동입력기, 윈도우 7 에서 HTTPS TLS 1.2 사용관련 레지스트리값을 설정합니다. 지금 관리자권한으로 자동 설정하시겠습니까?, 30
				IfMsgBox, Yes
				{
					MsgBox, 관리자권한으로 다시 실행합니다. 실행 후 곧바로 도움말->업데이트 확인을 해주셔야 설정이 완료됩니다.
					if A_IsCompiled
						Run *RunAs "%A_ScriptFullPath%" /restart
					else
						Run *RunAs "%A_AhkPath%" /restart "%A_ScriptFullPath%"
					ExitApp
				}
				else
				{
					MsgBox, 직접 HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp아래에 DWORD키 DefaultSecureProtocols의 값을 16진수 A00 (10진수 2560) 으로 생성 혹은 설정해주세요.
				}
			}
		}
	}
	Get(url)
	{
		try
		{
			this.http.open("GET", url, False)
			if (A_OSVersion = "WIN_7")
			{
				; Msxml2.XMLHTTP 에서는 max-age=0 가 안 먹힘.
				this.http.setRequestHeader("Pragma", "no-cache")
				this.http.setRequestHeader("Cache-Control", "no-cache, no-store")
				this.http.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT")
			}
			else
			{
				this.http.setRequestHeader("Cache-Control", "max-age=0")
			}
			this.http.Send()
			return this.http.responseText
		}
		catch e
		{
		}
		return ""
	}
}
class CHtmlUtil
{
	__New()
	{
		Gui, Add, ActiveX, hWndhWndHtmlUtill hidden, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		this.wb := WBGet("ahk_id " hWndHtmlUtill)
		this.wb.document.open()
		this.wb.document.write("")
		this.wb.document.close()
	}
	Escape(str)
	{
		return this.wb.document.parentWindow.escape(str)
	}
	Unescape(str)
	{
		return this.wb.document.parentWindow.unescape(str)
	}
	ReplaceHtmlSpeicalChars(str)
	{
		this.wb.document.body.innerHTML := str
		return this.wb.document.body.innerText
	}	
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Chrome 기반 브라우저 지원 클래스들
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CChrome
{
	__New()
	{
		this.port := 9222
		this.id := 1
		this.exename := "chrome"
		this.lnkname := "Chrome"
		this.korname := "크롬"
		this.titlesuffix := "Chrome"
		this.html := new CHtmlUtil()
	}
	Unescape(value)
	{
		return this.html.Unescape(value)
	}
	Launch(port := 9222)
	{
		exe := this.exename
		lnk := this.lnkname
		RegRead, path, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\%exe%.exe
		if (!path)
		{
			FileGetShortcut, %A_StartMenuCommon%\Programs\%lnk%.lnk, path
			if (!path)
			{
				FileGetShortcut, %A_StartMenu%\Programs\%lnk%.lnk, path
			}
		}
		if (FileExist(path))
		{
			this.path := path
		}
		else
		{
			MsgBox, , %lnk% Error, "설치된 경로를 찾을수 없습니다"
			return
		}
		target := this.path " --remote-debugging-port=" port " --user-data-dir=""" A_ScriptDir "\" exe "profile_autocoder"""
		Run, %target%
		this.port := port
		Loop, 10
		{
			Sleep, 200
			if (this.IsExist())
			{
				break
			}
		}
	}
	IsExist()
	{
		for proc in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process where name='" this.exename ".exe'")
		{
			if (InStr(proc.CommandLine, "--remote-debugging-port=" this.port " --user-data-dir"))
			{
				return WinExist("ahk_pid " proc.ProcessId)
			}
		}
		return false
	}
	GetWebSocketUrl(value, byUrl := false)
	{
		; 크롬 디버거용 로컬서버에서 디버깅주소가져오기임. 모두 로컬주소로 외부서버로 나가는 일 없음
		http := new CHTTP()
		list := JSON.Load(http.Get("http://127.0.0.1:" this.port "/json/list"))
		if (!list)
		{
			return -1
		}
		Loop, % list.MaxIndex()
		{
			if (byUrl)
			{
				if (InStr(list[A_Index].url, value))
				{
					return list[A_Index].webSocketDebuggerUrl
				}
			}
			else if (this.html.ReplaceHtmlSpeicalChars(list[A_Index].title) = value)
			{
				return list[A_Index].webSocketDebuggerUrl
			}
		}
		return ""
	}
}
class CMicrosoftEdge extends CChrome
{
	__New()
	{
		base.__New()
		this.id := 2
		this.exename := "msedge"
		this.lnkname := "Microsoft Edge"
		this.korname := "엣지"
		this.titlesuffix := "개인 - Microsoft​ Edge"
	}
}
class CNaverWhale extends CChrome
{
	__New()
	{
		base.__New()
		this.id := 3
		this.exename := "whale"
		this.lnkname := "네이버 웨일"
		this.korname := "웨일"
		this.titlesuffix := "Whale"
	}
}
class CWebSocket extends CWindow
{
	; 크롬 로컬 디버거 서버랑 WebSocket통신을 하기위한 용도로 익스플로러 ActiveX를 하는 호스팅하는 것임
	; 데이터교환흐름 AHK자동입력기<->익스플로러 로컬페이지<->크롬 로컬디버거서버
	__New(url)
	{
		static id := 0
		this.url := url
		guiname := "WebSocket" id++
		this.guiname := guiname
		
		Gui, %guiname%:+Owner1 +hWndhWnd
		Gui, %guiname%:Add, ActiveX, hWndhWndAX, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=edge'>
		Sleep, 100
		wb := WBGet("ahk_id " hWndAX)
		base.__New(hWnd)
		html =
(
<script>
var ws = null;
function Init(url)
{
	ws = new WebSocket(url);
	ws.onopen = EventHandler;
	ws.onclose = EventHandler;
	ws.onerror = EventHandler;
	ws.onmessage = EventHandler;
}
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e);
	}
}
</script>
)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		this.ie.Init(url)
	}
	__Delete()
	{
		this.ie := ""
		this.wb := ""
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	Send(data)
	{
		this.ie.ws.send(data)
	}
	Close(code:=1000, reason:="")
	{
		this.ie.ws.close(code, reason)
	}
	Destroy()
	{
		this.ie._EventHandler := ""
		guiname := this.guiname
		Gui, %guiname%:Destroy
	}	
}
class CChromeWSClient extends CWebSocket
{
	__New(url)
	{
		this.boolean_false := {boolean : false}
		this.boolean_true := {boolean : true}
		this.bConnected := false
		this.responses := Array()
		this.fnPing := this.Ping.Bind(this)
		base.__New(url)
		Loop, 20
		{
			if (this.bConnected)
			{
				break
			}
			Sleep, 50
		}
	}
	__Delete()
	{
		base.__Delete()
	}
	Call(method, params:="", bWait := true)
	{
		if (!this.bConnected)
		{
			return ""
		}
		id := 1
		if (this.responses.MaxIndex())
		{
			id := this.responses.MaxIndex() + 1
		}
		data := Object()
		data.id := id
		data.method := method
		if (params)
		{
			data.params := params
		}
		datastr := StrReplace(StrReplace(JSON.Dump(data), "{""boolean"":0}", "false"), "{""boolean"":1}", "true")
		this.Send(datastr)
		if (!bWait)
		{
			return
		}
		this.responses[id] := false
		Loop, 100
		{
			if (this.responses[id])
				break
			sleep, 50
		}
		response := this.responses.Delete(id)
		if (response)
		{
			if (response.error)
			{
			}
			;LogMessage("Response: " JSON.Dump(response))
			return response.result
		}
		return ""
	}
	HandleJavaScriptDialog(accept := true)
	{
		params := {}
		params.accept := accept ? this.boolean_true : this.boolean_false
		response := this.Call("Page.handleJavaScriptDialog", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
		
	}
	Navigate(url)
	{
		params := {}
		params.url := url
		response := this.Call("Page.navigate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.frameId
		
	}
	Evaluate(expression)
	{
		params := {}
		params.expression := expression
		params.objectGroup := "console"
		params.includeCommandLineAPI := this.boolean_true
		params.silent := this.boolean_false
		params.returnByValue := this.boolean_false
		params.userGesture := this.boolean_true
		params.awaitPromise := this.boolean_false
		response := this.Call("Runtime.evaluate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
	}
	Ping()
	{
		this.Call("Browser.getVersion", "",false)
	}
	GetVersion()
	{
		return this.Call("Browser.getVersion")
	}
	OnOpen(e)
	{
		this.bConnected := true
		ping := this.fnPing
		SetTimer, %ping%, 15000
	}
	OnMessage(e)
	{
		data := JSON.Load(e.data)
		if (this.responses.HasKey(data.id))
		{
			this.responses[data.id] := data
		}
	}
	OnClose(e)
	{
		this.Destroy()
		this.bConnected := false
		ping := this.fnPing
		SetTimer, %ping%,  Delete
		; 반드시 지워야 클래스오브젝트가 릴리스됨.
		this.fnPing := ""
		this.ie.ws := ""
		_app.PostMessage(_app.WM_WEBSOCKET_DISCONNECTED, 0, 0)
	}
	OnError(e)
	{
	}
	Disconnect()
	{
		if (this.bConnected)
			base.Close()
		Loop, 20
		{
			if (!this.bConnected)
				break
			Sleep, 50
		}
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Webbrowser classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CWebBrowser extends CWindow
{
	__New(n, h, l := "", c := "")
	{
		this.wb := ""
		this.name := n
		this.homepage_url := h
		this.login_url := h l
		this.charging_url := h c
	}
	SetChargingUrl(url)
	{
		this.charging_url :=  this.homepage_url url
	}
	SetPageError()
	{
		this.err .= "활성화된 '" this.name "' 페이지를 찾을수 없습니다. `r`n"
		this.err .= this.name " 로그인 페이지로 이동합니다. 로그인 후 다시 실행을 눌러주세요"
	}
	SetHWnd(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " hwnd
		return WinExist(this.title)
	}
	GetDomain(url)
	{
		if (RegExMatch(url, "O)\/\/([\w\.]+)", matches))
		{
			return matches[1]
		}
		return ""
	}
}
class CWBInternetExplorer extends CWebBrowser
{
	__Delete()
	{
		this.wb := ""
	}
	GetBrowserInfo()
	{
		return this.wb.document.parentWindow.navigator.userAgent
	}
	Init()
	{
		this.err := ""
		if (!this.SetHWnd(WinExist("ahk_class IEFrame")))
		{
			this.err .= "인터넷 익스플로러가 실행중이지 않습니다`r`n"
			this.SetPageError()
			wb := ComObjCreate("InternetExplorer.Application")
			wb.Visible := true
			wb.Navigate(this.login_url)
			Loop, 50
			{
				Sleep, 200
				if (wb.document.readyState = "complete")
				{
					break
				}
			}
			ObjRelease(wb)
			return this.Init()
		}
		this.wb := WBGet()
		if (this.wb)
		{
			try
			{
				this.WaitComplete()
			}
			catch e
			{
				this.err := "웹브라우저 컨트롤 오류 : " e.message "`r`n"
				this.err .= "회복할수 없는 오류이니 IE 브라우저를 종료후 다시 실행해주세요"
				this.wb := ""
				return false
			}
			return true
		}
		this.err := "IWebBrowserApp Com Object를 가져올 수 없습니다. `r`n"
		this.err .= "회복할수 없는 오류이니 IE 브라우저를 종료후 다시 실행해주세요"
		return false
	}
	WaitComplete()
	{
		Loop, 50
		{
			Sleep, 200
			if (this.wb.document.readyState = "complete")
			{
				return true
			}
		}
		return false
	}
	GotoUrl(url)
	{
		this.Activate()
		current_url := SubStr(this.wb.document.location.href, 6)
		if (InStr(url, current_url))
		{
			this.wb.document.location.reload(false)
			return this.WaitComplete()
		}
		this.ControlSetText("Edit1", url)
		Sleep, 200
		this.ControlSend("Edit1", "{Enter}")
		Sleep, 500
		this.WaitComplete()
		Loop, 10
		{
			current_url := SubStr(this.wb.document.location.href, 6)
			if (InStr(url, current_url))
			{
				return true
			}
			else
			{

				this.wb := WBGet()
			}
		}
		return false
	}
	
	CheckState()
	{
		this.err := ""
		if (!InStr(this.wb.document.location.href, this.GetDomain(this.homepage_url)))
		{
			this.SetPageError()
			this.win := new CWindow(WinExist("ahk_class IEFrame"))
			title := this.win.GetTitle()
			if (title != "빈 페이지 - Internet Explorer" && title != "새 탭 - Internet Explorer")
			{
				; 새 탭 열기
				Send, ^t
				Loop, 20
				{
					Sleep, 200
					if (this.win.GetTitle() = "새 탭 - Internet Explorer")
					{
						break
					}
					else
					{
					}
				}
				Sleep, 1000
			}
			if (!this.GotoUrl(this.login_url))
			{
				; WB 재설정 해줌
				this.wb := ""
				return false
			}
		}
		return true
	}
}
class CWBChrome extends CWebBrowser
{
	__Delete()
	{
		if (this.wb)
		{
			this.wb.Disconnect()
		}
		this.wb := ""
	}
	Unescape(value)
	{
		return _app.chrome.Unescape(value)
	}
	GetBrowserInfo()
	{
		result := this.wb.GetVersion()
		return result.userAgent
	}
	Init(bLaunch := true)
	{
		this.err := ""
		name := _app.chrome.korname
		if (!this.SetHWnd(_app.chrome.IsExist()) && bLaunch)
		{
			this.err := "개발자모드로 실행된 " name "창이 존재하지 않습니다. " name "을 개발자모드로 실행합니다. `r`n"
			_app.OnChromeLaunch()
			Loop, 40
			{
				Sleep, 250
				if (this.SetHWnd(_app.chrome.IsExist()))
				{
					break
				}
			}
		}
		if (!this.Exist())
		{
			this.err .= "개발자모드로 실행된 " name "창이 존재하지 않습니다"
			return false
		}
		if (!this.InitWSClient())
		{
			return false
		}		
		this.Activate()
		return true
	}
	OpenNewTab()
	{
		; 새 탭 열기
		this.wb.Disconnect()
		this.wb := ""
		Send, ^t
		url := this.GetWebSocketUrl("새 탭")
		if (url)
		{
			this.wb := new CChromeWSClient(url)
		}
	}
	GetWebSocketUrl(title)
	{
		Loop, 10
		{
			Sleep, 100
			url := _app.chrome.GetWebSocketUrl(title)
			if (url)
			{
				return url
			}
		}
		return ""
	}
	InitWSClient()
	{
		if (this.homepage_url)
		{
			url := _app.chrome.GetWebSocketUrl(this.homepage_url, true)
		}
		if (!url)
		{
			title := this.GetTitle()
			if (RegExMatch(title, " - " _app.chrome.titlesuffix "$"))
			{
				title := RegExReplace(title, " - " _app.chrome.titlesuffix "$")
			}
			else
			{
				title := RegExReplace(title, " - .+$")
			}
			url := _app.chrome.GetWebSocketUrl(title)
		}
		if (url = -1)
		{
			this.err := _app.chrome.korname " DevTool의 /json/list 엔드포인트에 연결할수 없습니다."
			return false
		}
		else if (!url)
		{
			this.err := "현재 창에 대한 디버깅주소를 못찾음"
			return false
		}
		if (this.wb)
		{
			if (this.wb.url != url || !this.wb.bConnected)
			{
				this.wb.Disconnect()
				this.wb := new CChromeWSClient(url)
			}
		}
		else
		{
			this.wb := new CChromeWSClient(url)
		}
		return true
	}
	CheckState()
	{
		result := this.wb.Evaluate("document.location.href")
		this.err := ""
		if (!InStr(result.value, this.GetDomain(this.homepage_url)))
		{
			this.SetPageError()
			if (!InStr(this.GetTitle(),"새 탭"))
			{
				this.OpenNewTab()
			}
			if (this.GotoUrl(this.login_url))
			{
				Send, {Tab}
				Sleep, 1000
			}
			else
			{
				this.err .= "새탭을 못엶. 다시 실행시도해주세요"
				return false
			}
		}
		return true
	}
	GotoUrl(url)
	{
		if (!this.wb)
		{
			return false
		}
		result := this.wb.Navigate(url)
		if (result)
		{
			if (this.WaitComplete())
			{
				return true
			}
		}
		return false
	}
	WaitTitle(title)
	{
		Loop, 10
		{
			Sleep, 500
			if (InStr(this.GetTitle(), title))
			{
				this.WaitComplete()
				return true
			}
		}
		return false
	}
	WaitComplete()
	{
		Loop, 40
		{
			Sleep, 250
			result := this.wb.Evaluate("document.readyState")
			if (result && result.value = "complete")
			{
				return true
			}
		}
		return false
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GiftCode class
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CGiftCode
{
	codes := Object()
	__New(b, n, r, h, l, c, p := 10)
	{
		this.browser := b
		this.name := n
		this.regex := r
		this.win := b ? new CWBChrome(n, h, l, c) : new CWBInternetExplorer(n, h, l, c)
		this.npp := p
		this.npp_default := p
		this.issued_date := 0
		this.exchange := false
		this.issued_company := 0
		this.phone_number := ""
		this.exchange_urls := Object()
	}
	ArrangeCode()
	{
	}
	ArrangeExCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 12)
			{
				if (this.name = "해피머니" && this.issued_company = "기프티콘")
				{
					arr.Push(Array(codes, this.phone_number))
				}
				else
				{
					arr.Push(Array(codes))
				}
			}
		}
		this.codes := arr
	}
	AutoInput()
	{
		return false
	}
	AutoInputEx()
	{
		if (this.codes.MaxIndex() = 0)
		{
			this.err := "선택된 상품권이 하나도 없습니다. 다시 선택해주세요"
			return false
		}
		if (this.exchange)
		{
			Loop, % this.npp
			{
				row := A_Index + this.page_base
				if (row > this.codes.MaxIndex())
				{
					break
				}
				if (this.GotoCharging())
				{
					if (_app.setting.ex_charging_interval)
					{
						_app.AppendLog(Format("{1:.2f}", _app.setting.ex_charging_interval/1000)  " 초간 쉽니다.")
						Sleep, % _app.setting.ex_charging_interval
					}
				}
				else
				{
					return false
				}
				if (!this.AutoExchangeInput(row))
				{
					return false
				}
			}
			return true
		}
		else
		{
			return this.GotoCharging() && this.AutoInput()
		}
	}
	AutoExchangeInput(row)
	{
		return false
	}
	AutoLogin(loginfo)
	{
		return false
	}
	ConfirmExchangeErrorGoNext(row)
	{
		_app.AppendLog("교환에 실패했습니다.")
		if (row < this.codes.MaxIndex())
		{
			MsgBox, 4, 자동입력기, 교환권 교환에 실패했습니다. 그래도 다음번호로 계속 진행하시겠습니까?, 30
			IfMsgBox, Yes
			{
				return true
			}
			return false
		}				
		return true
	}
	GetBrowserInfo()
	{
		return this.win.GetBrowserInfo()
	}
	GetName()
	{
		name := this.name
		if (this.exchange)
		{
			name .= " " this.issued_company
		}
		else
		{
			name .= " 상품권"
		}
		return name
	}
	GetNumberOnly(str)
	{
		return RegExReplace(str, "[^\d]")
	}
	GetError()
	{
		err := this.err 
		if (this.win.err)
		{
			err .= "`r`n" this.win.err
		}
		this.err := ""
		this.win.err := ""
		return err
	}
	GetExchangeInfo(ByRef content)
	{
		regexp := "Oi)(기프티쇼|기프티콘|기프트팝|아이넘버|giftishow|gifticon|giftpop|inumber)"
		if (RegExMatch(content, regexp, matches))
		{
			cnames_ko := ["기프티쇼", "기프티콘", "기프트팝", "아이넘버"]
			cnames_en := ["giftishow", "gifticon", "giftpop", "inumber"]
			this.issued_company := matches[1]
			Loop, % cnames_en.MaxIndex()
			{
				if (this.issued_company = cnames_en[A_Index])
				{
					this.issued_company := cnames_ko[A_Index] 
					break
				}
			}
		}
		if (RegExMatch(content, "O)수신.*(01[\d\-]{9,})", matches))
		{
			this.phone_number := SubStr(RegExReplace(matches[1], "-"), 1, 11)
		}
		if (!this.issued_company && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		if ((this.name = "컬쳐랜드" || (this.name = "해피머니" && this.issued_company = "기프티콘")) && ! this.phone_number && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		url := this.exchange_urls[this.issued_company]
		if (url)
		{
			this.win.SetChargingUrl(url)
		}
		else
		{
			this.err := this.issued_company " 의 " this.name " 교환권은 지원하지 않습니다."
			return false
		}
		return true
	}
	GetCode(row)
	{
		if (this.codes[row])
		{
			Loop, % this.codes[row].MaxIndex()
			{
				code .= this.codes[row][A_Index] "-"
			}
			StringTrimRight, code, code, 1
			return code
		}
		return 0
	}
	GetCurrentPageInfo()
	{
		return "다음 실행될 페이지는 " this.page " / " this.total_page " 페이지입니다"	
	}
	GetRowCountPrefix(row)
	{
		max_len := StrLen(this.codes.MaxIndex())
		prefix := "0000"
		return SubStr(prefix, 1, max_len - StrLen(row)) row "/" this.codes.MaxIndex() " : "
	}
	GetUserInputExchangeInfo()
	{
		dlg := new CExchangeInfoDialog(this.name, this.issued_company)
		if (dlg.DoModal())
		{
			if (!this.issued_company)
			{
				_app.editContent.AppendText("`r`n`r`n발행회사 : "  dlg.issued_company "`r`n")
			}
			if (!this.phone_number && dlg.phone_number)
			{
				_app.editContent.AppendText("`r`n수신 : " dlg.phone_number "`r`n")
			}
			this.issued_company := dlg.issued_company
			this.phone_number := dlg.phone_number
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}
	GetUserInputIssuedDate()
	{
		dlg := new CIssuedDateDialog()
		if (dlg.DoModal())
		{
			_app.editContent.AppendText("`r`n`r`n발행일 : "  dlg.issued_date "`r`n")
			this.issued_date := dlg.issued_date
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}	
	GotoCharging()
	{
		_app.ExitIfStop()
		this.err := ""
		if (!this.win.GotoUrl(this.win.charging_url))
		{
			this.err := "충전페이지 이동에 실패했습니다"
			return false
		}
		this.win.Activate()
		Sleep, 1000
		return true
	}
	InitWebBrowser()
	{
		if (this.win.Init())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			this.err := "로그인 해주세요"
			return this.win.CheckState()
		}
		return false
	}
	IsLogined()
	{
		return false
	}
	Load()
	{
		if (!this.view.bItemChanged)
		{
			return true
		}
		this.view.Activate()
		if (this.view.GetCount("S") = 0)
		{
			this.err := "선택된 상품권이 하나도 없습니다"
			return false
		}
		names := StrSplit(this.view.name, " ")
		this.name := names[1]
		this.exchange := (names[2] != "상품권")
		if (this.exchange)
		{
			this.issued_company := names[2]
			this.win.SetChargingUrl(this.exchange_urls[this.issued_company])
			this.npp_default := _app.setting.ex_charging_auto ? 10000 : 1
		}
		this.codes := Array()
		this.view.selections := Array()
		row := 0
		while(row := this.view.GetNext(row))
		{
			this.codes.Push(StrSplit(this.view.rows[row][2], "-"))
			this.view.selections.Push(row)
			this.view.SetUsed(row, false)
		}
		this.view.bItemChanged := false
		this.SetPage(1)
		return true
	}
	Parse(ByRef content)
	{
		this.ParseRegex(content)
		this.ArrangeCode()
		if (this.codes.MaxIndex() > 0)
		{
			if (this.name = "해피머니" && this.codes[1][5] = 0)
			{
				if (RegExMatch(content, "O)발행일[^\d]*(20[\d\_\-]{6,})", matches))
				{
					this.issued_date := this.GetNumberOnly(matches[1])
					if (StrLen(this.issued_date) != 8)
					{
						this.issued_date := 0
					}
				}
				else if (RegExMatch(content, "Os)발행일.*(20\d{6})", matches))
				{
					this.issued_date := matches[1]
				}
				if (!this.issued_date && !this.GetUserInputIssuedDate())
				{
					return false
				}
				Loop, % this.codes.MaxIndex()
				{
					this.codes[A_Index][5] := this.issued_date
				}
			}
		}
		else
		{
			this.regex :=  "O)[\s\n\,\:]([\d\-\_]{12,})"
			this.ParseRegex(content)
			if (this.codes.MaxIndex() > 0)
			{
				this.exchange := this.GetExchangeInfo(content)
				if (!this.exchange)
				{
					return false
				}
				this.npp_default := 10000
				this.ArrangeExCode()
			}
		}
		if (this.codes.MaxIndex() < 1)
		{
			if (this.exchange)
			{
				this.err := this.issued_company " " this.name " 교환 쿠폰번호를 하나도 찾을수 없습니다."
			}
			else
			{
				this.err := this.name " 핀번호를 하나도 찾을수 없습니다."
			}
			return false
		}
		this.SetPage(1)
		return true
	}
	ParseRegex(ByRef content)
	{
		pos := 1
		while (pos := RegExMatch(content, this.regex, matches, pos))
		{
			code := matches[1]
			pos += matches.Len(0)
			if (matches.Count() = 3)
			{
				if (matches[2] && !Instr(matches[2], "인증번호"))
				{
					pos -= matches.Len(3)
				}
				else
				{
					code .= matches[3]
				}
			}
			code := this.GetNumberOnly(code)
			this.codes.Push(code)
		}
	}
	Send(row, col, skip := false)
	{
		_app.ExitIfStop()
		if (!skip)
		{
			Sleep, % _app.setting.send_interval
			Send, % this.codes[row][col]
		}
		if (col = this.codes[row].MaxIndex())
		{
			this.SetUsed(row)
		}
		if (_app.setting.skip_send_logging)
		{
			return
		}
		if (col = 1)
		{
			_app.editLog.AppendText(this.GetRowCountPrefix(row))
		}
		_app.editLog.AppendText(this.codes[row][col])
		if (col = this.codes[row].MaxIndex())
		{
			_app.editLog.AppendText("`r`n")
		}
		else
		{
			_app.editLog.AppendText("-")
		}
	}
	SendExchange(row)
	{
		_app.ExitIfStop()
		code := this.codes[row][1]
		_app.editLog.AppendText(this.GetRowCountPrefix(row) code "`r`n")
		Send %code%
	}
	SetInputElementsError()
	{
		this.err := this.name " 입력창의 구성요소를 찾을수 없습니다. 상품권 번호 입력창이 띄워져 있는지 확인하세요"
	}
	SetPage(page)
	{
		this.npp := (this.exchange && !_app.setting.ex_charging_auto) ? 1 : this.npp_default
		this.total_page := Ceil(this.codes.MaxIndex() / this.npp)
		if (page >= 1 && page <= this.total_page)
		{
			this.page := page
			this.page_base := (this.page - 1) * this.npp
			if (this.total_page > 1 && this.view)
			{
				this.view.Activate()
				this.view.Modify(0, "-Select")
				Loop, % this.npp
				{
					row := this.page_base + A_Index
					if (row > this.view.selections.MaxIndex())
					{
						break
					}
					if (A_Index = 1)
					{
						this.view.EnsureVisible(this.view.selections[row] - 1)
					}
					this.view.Modify(this.view.selections[row], "Select")
				}
			}
			return true
		}
		return false
	}
	SetUsed(row)
	{
		this.view.SetUsed(this.view.selections[row])
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DataSender
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CSTKDataSenderCR extends CGiftCode
{
	__New()
	{
		send_path := "/normal.do?serviceId=S_ETC_0051&viewId=V_CENT5000"
		base.__New(1, "티월드", "", "https://www.tworld.co.kr/", send_path, send_path)
		this.sms := ""
		this.cool_down := 0
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("escape(document.getElementById('gnb_login').innerText)")
		if (InStr(_app.chrome.Unescape(result.value), "로그아웃"))
		{
			return true
		}
		return false
	}
	Init(fetcher)
	{
		if (fetcher = 0)
		{
			this.sms := new CMSYourPhoneMessageReader()
		}
		else if (fetcher = 1)
		{
			this.sms := new CGoogleMessageReader()
		}
		else if (fetcher = 2)
		{
			this.sms := new CPushbulletMessageReader()
		}
		else
		{
			this.AppendLog("지원하지 않는 문자수신 방식입니다")
			return
		}
		if (!this.sms.Init())
		{
			this.err := this.sms.err
			return false
		}
		if (!this.sms.GetLastMessage(msg, prefix))
		{
			this.err := "문자어플에서 SK텔레콤을 선택하세요"
		}
		this.err := msg
		return this.InitWebBrowser()
	}
	AutoSend(ByRef lv)
	{
		if (!lv.GetCount())
		{
			this.err := "보낼 번호가 없습니다"
			return false
		}
		if (lv.GetCount("S"))
		{
			row := 0
			while(row := lv.GetNext(row))
			{
				if (!this.AutoSendLVRow(lv, row))
				{
					return false
				}
			}
		}
		else
		{
			Loop, % lv.GetCount()
			{
				if (!this.AutoSendLVRow(lv, A_Index))
				{
					return false
				}
			}
		}
		return true
	}
	WaitCoolDown()
	{
		if (this.cool_down)
		{
			while((left := this.cool_down - A_TickCount) > 0)
			{
				_app.ExitIfStop()
				_app.AppendLog("데이터선물 재전송 가능시간까지 " Round(left/1000) " 초 남았습니다")
				if (left > 2000)
				{
					Sleep, 2000
				}
				else
				{
					Sleep, %left%
				}
			}
		}
	}
	HandleCertPopup()
	{
		url := this.win.GetWebSocketUrl("SMS 인증 | T world")
		if (!url)
		{
			this.err := "SMS 인증 창을 찾을수 없습니다"
			return false
		}
		this.SaveLastMessage()
		popup := new CChromeWSClient(url)
		popup.Evaluate("document.getElementsByClassName('btnXs btnDgray')[0].click()")
		Sleep, 2000
		WinActivate, SMS 인증 | T world - Chrome
		Send, {Enter}
		if (!this.GetCertNumber(certno))
		{
			this.err := "인증번호를 가져오지 못했습니다"
			return false
		}
		popup.Evaluate("document.getElementById('certNum').value='" certno "'")
		popup.Evaluate("document.getElementsByClassName('btnS btnBlack')[0].click()")
		return true
	}
	SendData(name, m1, m2, m3, amount)
	{
		this.WaitCoolDown()
		if (!this.GotoCharging())
		{
			return false
		}
		result := this.win.wb.Evaluate("document.getElementById('mobile2')")
		if (result.subtype != "node")
		{
			this.SetInputElementsError()
			return false
		}
		
		m1_index := this.GetM1Index(m1)
		if (m1_index > 0)
		{
			this.win.wb.Evaluate("document.getElementsByClassName('con')[0].getElementsByTagName('A')[" m1_index "].click()")
		}
		this.win.wb.Evaluate("document.getElementById('mobile2').value='" m2 "'")
		this.win.wb.Evaluate("document.getElementById('mobile3').value='" m3 "'")
		this.win.wb.Evaluate("document.getElementsByClassName('btnL btnRed')[0].click()")
		;---------------------------- 인증창 --------------------------
		Sleep, 2000
		iRetry := _app.setting.cert_retry
		Loop, %iRetry%
		{
			if (this.HandleCertPopup())
			{
				break
			}
			else if (A_Index = iRetry)
			{
				this.err := "인증번호 수신에 실패했습니다"
				return false
			}
			else
			{
				_app.AppendLog("인증번호 수신에 실패했습니다. 인증번호를 재요청 합니다 (" (iRetry-A_Index) "회 남음)")
			}
		}
		;---------------------------- 1단계 선택 --------------------------
		if (!this.win.WaitTitle("1단계 데이터량 선택"))
		{
			this.err := "1단계 데이터량 선택 화면을 찾지 못했습니다"
			return false
		}
		Sleep, 1000
		
		result := this.win.wb.Evaluate("document.getElementsByClassName('dataResidual')[0].innerText")
		if (RegExMatch(result.value, "O)잔여 데이터 :[^\d]+([\d\.]+)GB", matches))
		{
			_app.AppendLog("잔여 데이터량 : " matches[1] " GB")
			if (amount > matches[1])
			{
				this.err := "데이터 잔여량이 부족합니다"
				return false
			}
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('phoneNum')[1].innerText")
		if (!RegExMatch(result.value, "O)^(.+)님의", matches))
		{
			this.err := "받을 사람 이름 정보를 찾을수 없습니다"
			return false
		}
		_app.AppendLog(matches[1])
		re := StrReplace(matches[1], "*", ".*")
		if (!RegExMatch(name, re))
		{
			this.err := "받을 사람 이름 정보가 다릅니다"
			return false
		}
		select_id := "data" Round(amount * 1000)
		
		this.win.wb.Evaluate("document.getElementById('" select_id "').click()")
		this.win.wb.Evaluate("document.getElementsByClassName('btnM btnRed')[0].click()")
		this.win.Activate()
		Send, {Enter}
		;---------------------------- 2단계 완료 --------------------------
		if (!this.win.WaitTitle("2단계 완료"))
		{
			this.err := "2단계 완료 화면을 찾지 못했습니다"
			return false
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('endTxt')[0].innerText")
		_app.AppendLog(result.value)
		this.cool_down := A_TickCount + _app.setting.cert_cooldown * 1000
		return true
	}
	AutoSendLVRow(ByRef lv, row)
	{
		_app.ExitIfStop()
		name := lv.GetText(row, 1)
		phone := lv.GetText(row, 2)
		sent := lv.GetText(row, 4)
		left := lv.GetText(row, 5)
		m1 := SubStr(phone, 1, 3)
		m2 := SubStr(phone, 5, 4)
		m3 := SubStr(phone, 10, 4)
		_app.AppendLog(phone " " name " 님에게 총 " left " GB 데이터 선물을 시작합니다")
		while (left > 0)
		{
			amount := 1
			if (left < amount)
			{
				amount := left
			}
			if (this.SendData(name, m1, m2, m3, amount))
			{
				sent += amount
				left -= amount
				left := Format("{1:.1f}", left)
				lv.Modify(row, "Col4", Format("{1:.1f}", sent))
				lv.Modify(row, "Col5", left)
				_app.AppendLog(amount " GB 선물 성공 - " left "GB 남았습니다")
			}
			else
			{
				return false
			}
		}
		_app.AppendLog(phone " " name " 님에게 데이터 선물을 완료했습니다")
		return true
	}
	SaveLastMessage()
	{
		this.sms.GetLastMessage(msg, prefix)
		this.lastmsg := msg
	}
	GetCertNumber(ByRef n)
	{
		bFound := false
		timeout := 60
		Loop, %timeout%
		{
			_app.ExitIfStop()
			Sleep, 1000
			this.sms.GetLastMessage(msg, prefix)
			if (msg && msg != this.lastmsg)
			{
				bFound := true
				break
			}
			else
			{
				_app.AppendLog(A_Index "/" timeout " : 새로운 문자 수신대기합니다.")
			}
		}
		if (!bFound)
		{
			this.err := "새로운 인증번호를 찾을수 없습니다"
			return false
		}
		if (RegExMatch(msg, "O)인증번호는 (\d{6})", matches))
		{
			n := matches[1]
			_app.AppendLog("새로 발견한 인증번호 :" n)
			return true
		}
		this.err := "마지막 메세지가 인증번호 관련 메세지가 아닙니다"
		return false
	}
	GetM1Index(m1)
	{
		avail := [ "010", "011", "016", "017", "018", "019" ]
		Loop, % avail.MaxIndex()
		{
			if (m1 = avail[A_Index])
			{
				return A_Index -1
			}
		}
		return -1
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Phone Message Readers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CMessageReader
{
	__New(n)
	{
		this.name := n
		this.messages := []
		this.page := ""
		this.last := ""
		this.skip_pincheck := false
	}
	Init()
	{
		return true
	}
	SetCurrentPage(name)
	{
		this.page := "[ " name " ]"
	}
	Fetch()
	{
		return false
	}
	SkipPinCheck(bCheck)
	{
		this.skip_pincheck := bCheck
	}
	AddMessage(ByRef msg, prefix)
	{
		bFound := this.skip_pincheck 
		pos := 1
		while (!bFound && pos := RegExMatch(msg, "O)([\d\-\_ ]{12,})", matches, pos))
		{
			if (StrLen(RegExReplace(matches[1], "[^\d]")) >= 12)
			{
				bFound := true
				break
			}
			pos += matches.Len(0)
		}
		if (bFound)
		{
			o := Object()
			o.prefix := prefix ? prefix : this.last
			o.time := this.GetTime(o.prefix)
			o.msg := msg
			this.last := o.prefix
			this.messages.Push(o)
		}
	}
	Filter(time, regex)
	{
		arr := Array()
		Loop, % this.messages.MaxIndex()
		{
			if (time = 0 || time <= this.messages[A_Index].time)
			{
				if (!regex || RegExMatch(this.messages[A_Index].msg, regex))
				{
					arr.Push(this.messages[A_Index])
				}
			}
			else
			{
			}
		}
		this.messages := arr
	}
	GetTime(prefix)
	{
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
	}
}
class CMSYourPhoneMessageReader extends CMessageReader
{
	__New()
	{
		base.__New("사용자 휴대폰")
		this.uia := new CCUIAutomation()
		this.elm_msg := ""
	}
	Init()
	{
		if (!this.uia.pi)
		{
			this.err := "오류 : UI Automation 프레임워크를 사용할수 없습니다"
			return false
		}
		hWnd := WinExist("ahk_exe ApplicationFrameHost.exe")
		TreeScope_Children := 2
		CoreWindow_Pos := 1
		cond_true := this.uia.CreateTrueCondition()	
		phone := new CIUIAutomationElement(new CIUIAutomationElementArray(new CIUIAutomationElement(this.uia.ElementFromHandle(hWnd)).FindAll(TreeScope_Children, cond_true)).GetElement(CoreWindow_Pos))
		name := phone.CurrentName()
		if (name != "사용자 휴대폰")
		{
			this.err := this.name "의 화면을 찾을 수 없습니다."
			if (name)
			{
				this.err .= "현재 창 이름은 " name " 입니다"
			}
			return false
		}
		children := new CIUIAutomationElementArray(phone.FindAll(TreeScope_Children, cond_true))
		child := new CIUIAutomationElement(children.GetElement(0))
		if (child.CurrentName() = "기능")
		{
			children := new CIUIAutomationElementArray(child.FindAll(TreeScope_Children, cond_true))
		}
		UIA_ListControlTypeId	:=	50008
		Loop, % children.GetLength()
		{
			child := new CIUIAutomationElement(children.GetElement(A_Index -1))
			if (child.CurrentName() = "메시지" && child.CurrentControlType() = UIA_ListControlTypeId)
			{
				this.elm_msg := child
				if (this.elm_msg.pi)
				{
					return true
				}
				else
				{
					this.err := this.name "의 인터페이스를 가져오지 못했습니다"
					return false
				}
			}
		}
		this.err := this.name "의 메시지 창을 찾을수 없습니다"
		return false
	}
	Fetch()
	{
		TreeScope_Children := 2
		UIA_ScrollPatternId	:= 10004
		cond_true := this.uia.CreateTrueCondition()	
		scroll := new CIUIAutomationScrollPattern(this.elm_msg.GetControlPattern(UIA_ScrollPatternId))
		if (!scroll.pi)
		{
			this.err := "스크롤 패턴을 찾을수 없습니다"
			return false
		}
		v := scroll.CurrentVerticalViewSize()
		vpercent := 0
		msglist := Object()
		while (vpercent <= 100)
		{
			scroll.SetScrollPercent(-1,  vpercent)
			if (vpercent = 100 || v = 100)
			{
				vpercent := 101
			}
			else
			{
				vpercent += v
				if (vpercent > 100)
				{
					vpercent := 100
				}
			}
			Sleep, 100
			children := new CIUIAutomationElementArray(this.elm_msg.FindAll(TreeScope_Children, cond_true))
			Loop, % children.GetLength()
			{
				child := new CIUIAutomationElement(children.GetElement(A_Index -1))
				msg := child.CurrentName()
				bFound := false
				Loop, % msglist.MaxIndex()
				{
					if (msglist[A_Index] = msg)
					{
						bFound := true
						break
					}
				}
				if(!bFound)
				{
					msglist.Push(msg)
					if (RegExMatch(msg, "O)\. +([^\.]+)의 메시지", matches))
					{
						prefix := matches[1]
						msg := StrReplace(msg, matches[0])
						if (RegExMatch(msg, "O)^([^\.]+)\.", matches))
						{
							msg := StrReplace(msg, matches[0])
							prefix := matches[1] " : " prefix
							this.SetCurrentPage(matches[1])
						}
						this.AddMessage(msg, prefix)
					}							
				}
			}
		}
		return true
	}
	GetTime(prefix)
	{
		;[+82 1588-4763 : ‎2020‎-‎03‎-‎04 ‎오후‎ ‎9‎:‎50]
		if (RegExMatch(prefix, "O)([^ ]+) +([^ ]+) +([^ ]+)$", matches))
		{
			time := RegExReplace(matches[3], "[^\d]")
			if (Instr(matches[2], "오후"))
			{
				time += 1200
			}
			time := RegExReplace(matches[1], "[^\d]") . Format("{1:04d}", time) . "00"
			return time
		}
		else
		{
		}
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		msg := "", prefix := ""
		TreeScope_Children := 2
		UIA_ScrollPatternId	:= 10004
		cond_true := this.uia.CreateTrueCondition()	
		scroll := new CIUIAutomationScrollPattern(this.elm_msg.GetControlPattern(UIA_ScrollPatternId))
		scroll.SetScrollPercent(-1,  100)
		children := new CIUIAutomationElementArray(this.elm_msg.FindAll(TreeScope_Children, cond_true))
		length := children.GetLength()
		if (length > 0)
		{
			child := new CIUIAutomationElement(children.GetElement(length -1))
			msg := child.CurrentName()
			if (RegExMatch(msg, "O)\. +([^\.]+)의 메시지", matches))
			{
				prefix := matches[1]
				msg := StrReplace(msg, matches[0])
				if (RegExMatch(msg, "O)^([^\.]+)\.", matches))
				{
					msg := StrReplace(msg, matches[0])
					prefix := matches[1] " : " prefix
				}

				return true
			}
			this.err := "메세지 시간정보를 찾을수 없습니다."
			return false
		}
		this.err := "메세지가 하나도 없습니다"
		return false
	}
}
class CChromeMessageReader extends CMessageReader
{
	__New(n, h)
	{
		base.__New(n)
		this.win := new CWBChrome(n, h)
	}
	Init()
	{
		if (this.win.Init() && this.win.CheckState())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			return true
		}
		this.err := this.win.err
		return false
	}
}
class CGoogleMessageReader extends CChromeMessageReader
{
	__New()
	{
		base.__New("구글 메시지", "https://messages.google.com/web")
	}
	Init()
	{
		if (!base.Init())
		{
			return false
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('title-container')[0].innerText)")
		if (!result.value)
		{
			this.err := this.name "에서 문자를 선택해 열어주세요"
			return false
		}
		this.SetCurrentPage(this.win.Unescape(result.value))
		return true
	}
	Fetch()
	{
		result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children.length")
		if (result.value < 1)
		{
			this.err := "구성요소를 찾을수 없습니다. 문자가 열려있는지 확인해주세요"
			return false
		}
		prefix := ""
		Loop, % result.value
		{
			root_i := A_Index - 1
			result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].tagName")
			if (result.value = "MWS-TOMBSTONE-MESSAGE-WRAPPER")
			{
				result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].innerText)")
				prefix := this.win.Unescape(result.value)
			}
			else if (result.value = "MWS-MESSAGE-WRAPPER")
			{
				result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].getElementsByClassName('text-msg-content').length")
				if (result.value)
				{
					Loop, % result.value
					{
						result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].getElementsByClassName('text-msg-content')[" A_Index - 1 "].innerText)")
						this.AddMessage(this.win.Unescape(result.value), prefix)
					}
				}
			}
		}
		return true
	}	
	GetTime(prefix)
	{
		static wdays := {"일요일" : 1 , "월요일" : 2, "화요일" : 3, "수요일" : 4, "목요일" : 5, "금요일" : 6, "토요일" : 7}
		if (RegExMatch(prefix, "O)(\d+년)?\s*(\d+월)?\s*(\d+일)?\s*([^ ]+요일)?.+(오전|오후) ([^ ]+)",matches))
		{
			year := matches[1] ? RegExReplace(matches[1], "[^\d]") : A_Year
			month := matches[2] ? Format("{1:02d}", RegExReplace(matches[2], "[^\d]")) : A_MM
			day := matches[3] ? Format("{1:02d}", RegExReplace(matches[3], "[^\d]")) : A_DD
			wday := matches[4] ? wdays[matches[4]] : A_Wday
			time := RegExReplace(matches[6], "[^\d]")
			if (matches[5] = "오후")
			{
				time += 1200
			}
			date := year month day Format("{1:04d}", time) "00"
			if (!matches[3])
			{
				day_before := wday - A_Wday
				if (day_before > 0)
				{
					day_before -= 7
				}
				date += %day_before%, D
			}
			return date
		}
		return A_Now
	}	
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		msg := ""
		prefix := ""
		result := this.win.wb.Evaluate("document.getElementsByTagName('mws-relative-timestamp').length")
		if (result.value > 0)
		{
			result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-relative-timestamp')[" (result.value - 1) "].innerText)")
			prefix := this.win.Unescape(result.value)
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('text-msg').length")
		if (result.value > 0)
		{
			result := this.win.wb.Evaluate("escape(document.getElementsByClassName('text-msg')[" (result.value - 1) "].innerText)")
			msg := this.win.Unescape(result.value)
			return true
		}
		return false
	}
}
class CPushbulletMessageReader extends CChromeMessageReader
{
	__New()
	{
		base.__New("Pushbullet", "https://www.pushbullet.com")
	}
	Init()
	{
		if (!base.Init())
		{
			return false
		}
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value < 1)
		{
			this.err := this.name "에서 문자를 선택해 열어주세요"
			return false
		}
		return true
	}
	Fetch()
	{
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value > 0)
		{
			length := result.value
			Loop, %length%
			{
				result := this.win.wb.Evaluate("document.getElementById('innerlist').children[" (A_Index - 1) "].children.length")
				if (result.value = 2)
				{
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].children[0].innerText)")
					prefix := this.win.Unescape(result.value)
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].children[1].innerText)")
					msg := this.win.Unescape(result.value)
				}
				else
				{
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].innerText)")
					msg := this.win.Unescape(result.value)
				}
				this.AddMessage(msg, prefix)
			}
		}
		return true
	}
	GetTime(prefix)
	{
		static wdays := {"Sunday" : 1 , "Monday" : 2, "Tuesday" : 3, "Wednesday" : 4, "Thursday" : 5, "Friday" : 6, "Saturday" : 7, "Today" : A_Wday, "Yesterday" : A_Wday -1 }
		static today := A_Year A_MM A_DD
		;  02/07/2020 
		; [Last Monday at 9:21 PM]
		if (RegExMatch(prefix, "O)(\d{2})/(\d{2})/(\d{4})", matches))
		{
			return matches[3] matches[1] matches[2] "000000"
		}
		else if (RegExMatch(prefix, "O)([^ ]+) at ([^ ]+) ([AP]M)", matches))
		{
			time := RegExReplace(matches[2], "[^\d]")
			if (matches[3] = "PM")
			{
				time += 1200
			}
			date := today Format("{1:04d}", time)
			wday := wdays[matches[1]]
			day_before := wday - A_Wday
			if (day_before > 0)
			{
				day_before -= 7
			}
			date += %day_before%, D
			return date
		}
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value > 0)
		{
			index := result.value - 1
			result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" index "].children[0].innerText)")
			prefix := this.win.Unescape(result.value)
			result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" index "].children[1].innerText)")
			msg := this.win.Unescape(result.value)
			return true
		}
		return false
	}
}
class CKakaoTalkMessageReader extends CMessageReader
{
	__New()
	{
		base.__New("카카오톡")
		this.win := ""
	}
	Init()
	{
		WinGet, windows, List
		Loop, %windows%
		{
			win := new CWindow(windows%A_Index%)
			if (win.GetClass() = "#32770" && win.GetProcessName() = "KakaoTalk.exe")
			{
				win.Activate()
				this.SetCurrentPage(win.GetTitle()) 
				this.win := new CWindow(win.ControlGet("EVA_VH_ListControl_Dblclk1"))
				if (this.win.Exist())
				{
					return true
				}
				this.err .= "카카오톡 대화창이 아닙니다"
				return false
			}
		}
		this.err := this.name " 대화창을 찾을수 없습니다"
		return false
	}
	Fetch()
	{
		; 전체선택
		this.win.SendMessage(0x07E9, 0x65, 0)
		; 복사
		this.win.SendMessage(0x07E9, 0x64, 0)
		txt := Clipboard
		arr_daily := Array()
		arr_daily_date := Array()
		pos := 1
		while (pos := RegExMatch(txt, "Om)^(\d{4}년.*요일)$", matches, pos))
		{
			arr_daily.Push(pos)
			arr_daily_date.Push(matches[1])
			pos += matches.Len(0)
		}
		Loop, % arr_daily.MaxIndex()
		{
			daily_date := arr_daily_date[A_Index]
			pos_start := arr_daily[A_Index] + StrLen(daily_date) + 2
			if (A_Index = arr_daily.MaxIndex())
			{
				daily_msg := SubStr(txt, pos_start)
			}
			else
			{
				daily_msg := Substr(txt, pos_start, arr_daily[A_Index +1] - pos_start)
			}
			arr_msg := Array()
			arr_msg_prefix := Array()
			arr_msg_datetime := Array()
			pos := 1
			while (pos := RegExMatch(daily_msg, "Om)^\[[^\]]+\]\s+\[(오. [\d\:]+)\] ", matches, pos))
			{
				arr_msg.Push(pos)
				arr_msg_prefix.Push(matches[0])
				arr_msg_datetime.Push(matches[1])
				pos += matches.Len(0)
			}
			Loop, % arr_msg.MaxIndex()
			{
				msg_date := daily_date " " arr_msg_datetime[A_Index]
				pos_start := arr_msg[A_Index] + StrLen(arr_msg_prefix[A_Index])
				if (A_Index = arr_msg.MaxIndex())
				{
					msg := SubStr(daily_msg, pos_start)
				}
				else
				{
					msg := Substr(daily_msg, pos_start, arr_msg[A_Index +1] - pos_start - 2)
				}
				this.AddMessage(msg, msg_date)
			}
		}
		return true
	}
	GetTime(prefix)
	{
		;[2020년 3월 4일 수요일 오전 10:28]
		if (RegExMatch(prefix, "O)(\d{4})년 (\d+)월 (\d+)일(.+)", matches))
		{
			time := RegExReplace(matches[4], "[^\d]")
			if (InStr(matches[4], "오후"))
			{
				time += 1200
			}
			return matches[1] . Format("{1:02d}", matches[2]) . Format("{1:02d}", matches[3]) .  Format("{1:04d}", time) . "00"
		}
		return A_Now
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 이하는 외부의 공개 WBGet함수, JSON 라이브러리 코드입니다. 
;; 자동입력기를 하나의 파일로 배포하기 위해 따로 Include하지 않고 
;; 원본소스에서 주석, 공백제거한후 코드에 이어 삽입했습니다.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; [WBGet function for AHK v1.1]
; WBGet function - AutoHotkey Community
; https://autohotkey.com/boards/viewtopic.php?f=6&t=39869
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WBGet(WinTitle="ahk_class IEFrame", Svr#=1) {               ;// based on ComObjQuery docs
   static msg := DllCall("RegisterWindowMessage", "str", "WM_HTML_GETOBJECT")
        , IID := "{0002DF05-0000-0000-C000-000000000046}"   ;// IID_IWebBrowserApp
;//     , IID := "{332C4427-26CB-11D0-B483-00C04FD90119}"   ;// IID_IHTMLWindow2
   SendMessage msg, 0, 0, Internet Explorer_Server%Svr#%, %WinTitle%
   if (ErrorLevel != "FAIL") {
      lResult:=ErrorLevel, VarSetCapacity(GUID,16,0)
      if DllCall("ole32\CLSIDFromString", "wstr","{332C4425-26CB-11D0-B483-00C04FD90119}", "ptr",&GUID) >= 0 {
         DllCall("oleacc\ObjectFromLresult", "ptr",lResult, "ptr",&GUID, "ptr",0, "ptr*",pdoc)
         return ComObj(9,ComObjQuery(pdoc,IID,IID),1), ObjRelease(pdoc)
      }
   }
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; JSON lib for AutoHotkey v2.1.3 [updated 04/18/2016 (MM/DD/YYYY)]
; 배포사이트 : https://github.com/cocobelgica/AutoHotkey-JSON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class JSON
{
class Load extends JSON.Functor
{
Call(self, ByRef text, reviver:="")
{
this.rev := IsObject(reviver) ? reviver : false
this.keys := this.rev ? {} : false
static quot := Chr(34), bashq := "\" . quot
, json_value := quot . "{[01234567890-tfn"
, json_value_or_array_closing := quot . "{[]01234567890-tfn"
, object_key_or_object_closing := quot . "}"
key := ""
is_key := false
root := {}
stack := [root]
next := json_value
pos := 0
while ((ch := SubStr(text, ++pos, 1)) != "") {
if InStr(" `t`r`n", ch)
continue
if !InStr(next, ch, 1)
this.ParseError(next, text, pos)
holder := stack[1]
is_array := holder.IsArray
if InStr(",:", ch) {
next := (is_key := !is_array && ch == ",") ? quot : json_value
} else if InStr("}]", ch) {
ObjRemoveAt(stack, 1)
next := stack[1]==root ? "" : stack[1].IsArray ? ",]" : ",}"
} else {
if InStr("{[", ch) {
static json_array := Func("Array").IsBuiltIn || ![].IsArray ? {IsArray: true} : 0
(ch == "{")
? ( is_key := true
, value := {}
, next := object_key_or_object_closing )
: ( value := json_array ? new json_array : []
, next := json_value_or_array_closing )
ObjInsertAt(stack, 1, value)
if (this.keys)
this.keys[value] := []
} else {
if (ch == quot) {
i := pos
while (i := InStr(text, quot,, i+1)) {
value := StrReplace(SubStr(text, pos+1, i-pos-1), "\\", "\u005c")
static tail := A_AhkVersion<"2" ? 0 : -1
if (SubStr(value, tail) != "\")
break
}if (!i)
this.ParseError("'", text, pos)
  value := StrReplace(value,  "\/",  "/")
, value := StrReplace(value, bashq, quot)
, value := StrReplace(value,  "\b", "`b")
, value := StrReplace(value,  "\f", "`f")
, value := StrReplace(value,  "\n", "`n")
, value := StrReplace(value,  "\r", "`r")
, value := StrReplace(value,  "", "`t")
pos := i
i := 0
while (i := InStr(value, "\",, i+1)) {
if !(SubStr(value, i+1, 1) == "u")
this.ParseError("\", text, pos - StrLen(SubStr(value, i+1)))
uffff := Abs("0x" . SubStr(value, i+2, 4))
if (A_IsUnicode || uffff < 0x100)
value := SubStr(value, 1, i-1) . Chr(uffff) . SubStr(value, i+6)
}if (is_key) {
key := value, next := ":"
continue
}} else {
value := SubStr(text, pos, i := RegExMatch(text, "[\]\},\s]|$",, pos)-pos)
static number := "number", integer :="integer"
if value is %number%
{
if value is %integer%
value += 0
}else if (value == "true" || value == "false")
value := %value% + 0
else if (value == "null")
value := ""
else
this.ParseError(next, text, pos, i)
pos += i-1
}next := holder==root ? "" : is_array ? ",]" : ",}"
}is_array? key := ObjPush(holder, value) : holder[key] := value
if (this.keys && this.keys.HasKey(holder))
this.keys[holder].Push(key)
}}
return this.rev ? this.Walk(root, "") : root[""]
}ParseError(expect, ByRef text, pos, len:=1)
{
static quot := Chr(34), qurly := quot . "}"
line := StrSplit(SubStr(text, 1, pos), "`n", "`r").Length()
col := pos - InStr(text, "`n",, -(StrLen(text)-pos+1))
msg := Format("{1}`n`nLine:`t{2}`nCol:`t{3}`nChar:`t{4}"
,     (expect == "")     ? "Extra data"
: (expect == "'")    ? "Unterminated string starting at"
: (expect == "\")    ? "Invalid \escape"
: (expect == ":")    ? "Expecting ':' delimiter"
: (expect == quot)   ? "Expecting object key enclosed in double quotes"
: (expect == qurly)  ? "Expecting object key enclosed in double quotes or object closing '}'"
: (expect == ",}")   ? "Expecting ',' delimiter or object closing '}'"
: (expect == ",]")   ? "Expecting ',' delimiter or array closing ']'"
: InStr(expect, "]") ? "Expecting JSON value or array closing ']'"
:                      "Expecting JSON value(string, number, true, false, null, object or array)"
, line, col, pos)
static offset := A_AhkVersion<"2" ? -3 : -4
throw Exception(msg, offset, SubStr(text, pos, len))
}Walk(holder, key)
{
value := holder[key]
if IsObject(value) {
for i, k in this.keys[value] {
v := this.Walk(value, k)
if (v != JSON.Undefined)
value[k] := v
else
ObjDelete(value, k)
}}
return this.rev.Call(holder, key, value)
}}
class Dump extends JSON.Functor
{
Call(self, value, replacer:="", space:="")
{
this.rep := IsObject(replacer) ? replacer : ""
this.gap := ""
if (space) {
static integer := "integer"
if space is %integer%
Loop, % ((n := Abs(space))>10 ? 10 : n)
this.gap .= " "
else
this.gap := SubStr(space, 1, 10)
this.indent := "`n"
}return this.Str({"": value}, "")
}Str(holder, key)
{
value := holder[key]
if (this.rep)
value := this.rep.Call(holder, key, ObjHasKey(holder, key) ? value : JSON.Undefined)
if IsObject(value) {
static type := A_AhkVersion<"2" ? "" : Func("Type")
if (type ? type.Call(value) == "Object" : ObjGetCapacity(value) != "") {
if (this.gap) {
stepback := this.indent
this.indent .= this.gap
}is_array := value.IsArray
if (!is_array) {
for i in value
is_array := i == A_Index
until !is_array
}str := ""
if (is_array) {
Loop, % value.Length() {
if (this.gap)
str .= this.indent
v := this.Str(value, A_Index)
str .= (v != "") ? v . "," : "null,"
}} else {
colon := this.gap ? ": " : ":"
for k in value {
v := this.Str(value, k)
if (v != "") {
if (this.gap)
str .= this.indent
str .= this.Quote(k) . colon . v . ","
}}
}if (str != "") {
str := RTrim(str, ",")
if (this.gap)
str .= stepback
}if (this.gap)
this.indent := stepback
return is_array ? "[" . str . "]" : "{" . str . "}"
}} else
return ObjGetCapacity([value], 1)=="" ? value : this.Quote(value)
}Quote(string)
{
static quot := Chr(34), bashq := "\" . quot
if (string != "") {
  string := StrReplace(string,  "\",  "\\")
, string := StrReplace(string, quot, bashq)
, string := StrReplace(string, "`b",  "\b")
, string := StrReplace(string, "`f",  "\f")
, string := StrReplace(string, "`n",  "\n")
, string := StrReplace(string, "`r",  "\r")
, string := StrReplace(string, "`t",  "")
static rx_escapable := A_AhkVersion<"2" ? "O)[^\x20-\x7e]" : "[^\x20-\x7e]"
while RegExMatch(string, rx_escapable, m)
string := StrReplace(string, m.Value, Format("\u{1:04x}", Ord(m.Value)))
}return quot . string . quot
}}
Undefined[]
{
get {
static empty := {}, vt_empty := ComObject(0, &empty, 1)
return vt_empty
}}
class Functor
{
__Call(method, ByRef arg, args*)
{
if IsObject(method)
return (new this).Call(method, arg, args*)
else if (method == "")
return (new this).Call(arg, args*)
}}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
